'use strict';

exports.__esModule = true;
exports.title = exports.Preview = undefined;
exports.head = head;

var _ramda = require('ramda');

var _ramda2 = _interopRequireDefault(_ramda);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactSeeds = require('react-seeds');

var _reactSeeds2 = _interopRequireDefault(_reactSeeds);

var _rgba = require('react-sow/rgba');

var _rgba2 = _interopRequireDefault(_rgba);

var _JSONComponent = require('./JSONComponent');

var _JSONComponent2 = _interopRequireDefault(_JSONComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Preview = exports.Preview = function Preview(_ref) {
	var ingredients = _ref.ingredients,
	    contentTree = _ref.contentTree;
	return _react2.default.createElement(_JSONComponent2.default, { json: contentTree, isDeserialized: true });
};

var title = exports.title = 'Raw';

var styleSheet = '\nhtml {\n\tfont-size: 18px;\n\tfont-size: calc(112.5% + 2 * (100vw - 600px) / 400);\n\tbackground-color: #eef8f8;\n\tcolor: #027362;\n}\n\nbody {\n\tbox-sizing: border-box;\n\tmax-width: 100vw;\n\tmargin: auto;\n\tpadding: 1.333333333rem 1.7em;\n\tline-height: ' + 4 / 3 + 'rem;\n\tfont-family: system, "-apple-system", "-webkit-system-font", BlinkMacSystemFont, "Helvetica Neue", "Helvetica", "Segoe UI", "Roboto", "Arial", "freesans", sans-serif, "Apple Color Emoji", "Segoe UI Emoji", "Segoe UI Symbol";\n\t-webkit-hypens: auto; -ms-hypens: auto; hypens: auto;\n}\n\n* {\n\tmargin: auto;\n}\n\np,\nul,\nol,\ndt,\npre,\nhr {\n\tmargin-bottom: ' + 2 / 3 + 'rem;\n}\n\nol {\n\tpadding-left: 2rem;\n}\n\nli {\n\tmargin-bottom: ' + 4 / 3 + 'rem;\n}\n\ndl,\ndd {\n\tmargin: auto;\n\twidth: auto;\n}\n\ndt {\n\tmargin-bottom: 0;\n\tfont-weight: bold;\n}\ndd {\n\tmargin-left: 1em;\n\tmargin-right: 0;\n}\n';

function head() {
	return _react2.default.createElement(
		'head',
		null,
		_react2.default.createElement('style', { children: styleSheet })
	);
}