/*!
 * gateau v0.2.2
 * MIT Licensed
 */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"), require("react-dom"), require("ramda"), require("mobx"), require("mobx-react"));
	else if(typeof define === 'function' && define.amd)
		define(["react", "react-dom", "ramda", "mobx", "mobx-react"], factory);
	else if(typeof exports === 'object')
		exports["Gateau"] = factory(require("react"), require("react-dom"), require("ramda"), require("mobx"), require("mobx-react"));
	else
		root["Gateau"] = factory(root["React"], root["ReactDOM"], root["R"], root["mobx"], root["mobxReact"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_2__, __WEBPACK_EXTERNAL_MODULE_3__, __WEBPACK_EXTERNAL_MODULE_6__, __WEBPACK_EXTERNAL_MODULE_24__, __WEBPACK_EXTERNAL_MODULE_25__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = __webpack_require__(1);


/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/index.js';

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactDom = __webpack_require__(3);

	var _App = __webpack_require__(4);

	var _App2 = _interopRequireDefault(_App);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function initGateauAppElements(appElements) {
		for (var i = 0; i < appElements.length; i++) {
			var appElement = appElements[i];
			var destinationID = appElement.getAttribute('data-destination');
			var contentElement = appElement.querySelector('.gateau_content');
			var ingredientsElement = appElement.querySelector('.gateau_ingredients');
			var scenariosElement = appElement.querySelector('.gateau_scenarios');
			var content = contentElement.textContent.trim();
			var ingredients = ingredientsElement ? JSON.parse(ingredientsElement.textContent) : [];
			var scenarios = scenariosElement ? JSON.parse(scenariosElement.textContent) : [];
			(0, _reactDom.render)(_react2.default.createElement(_App2.default, {
				initialContent: content,
				initialDestinationID: destinationID,
				initialIngredients: ingredients,
				initialScenarios: scenarios,
				__source: {
					fileName: _jsxFileName,
					lineNumber: 21
				},
				__self: this
			}), appElement);
		}
	}

	// Render app elements on the page
	initGateauAppElements(document.querySelectorAll('.gateau'));

	// Allow dynamic app elements in the future
	window.initGateauAppElements = initGateauAppElements;

	if (!window.promiseCollectedText) {
		window.promiseCollectedText = function (options) {
			return Promise.resolve(null);
		};
	}

	if (!window.promiseCollectedImageURL) {
		window.promiseCollectedImageURL = function (options) {
			return Promise.reject({ message: 'No collected service' });
		};
	}

/***/ },
/* 2 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_2__;

/***/ },
/* 3 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_3__;

/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/App.js';

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _Main = __webpack_require__(5);

	var _Main2 = _interopRequireDefault(_Main);

	var _createStateManager = __webpack_require__(113);

	var _createStateManager2 = _interopRequireDefault(_createStateManager);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var initialContent = 'Just add hashtags #primary\n\nCreate rich layouts just by typing #image #unsplash: dessert\n\nCreate fields #field\nAnd Buttons #button #primary\nBig and Small #button #small\n\nFeatures #link: @links.features\n\n@legal #small\n';

	/*
		# shorthand #primary
		## shorthand #secondary
		### shorthand #tertiary

		#collected:(hash)
	*/

	var ingredients = [{
		id: 'links',
		type: 'json',
		variations: [{
			rawContent: '{"features": "https://icing.space/features"}'
		}]
	}, {
		id: 'legal',
		type: 'text',
		variations: [{
			rawContent: 'Copyright Company Inc. 2016'
		}]
	}];

	var scenarios = [{
		links: 0,
		legal: 0
	}];

	exports.default = _react2.default.createClass({
		displayName: 'App',
		componentWillMount: function componentWillMount() {
			var _props = this.props,
			    initialContent = _props.initialContent,
			    initialDestinationID = _props.initialDestinationID,
			    initialDestinationDevice = _props.initialDestinationDevice,
			    initialIngredients = _props.initialIngredients,
			    initialScenarios = _props.initialScenarios,
			    initialActiveScenarioIndex = _props.initialActiveScenarioIndex;


			this.stateManager = (0, _createStateManager2.default)({
				content: initialContent,
				ingredients: initialIngredients,
				destinationID: initialDestinationID,
				destinationDevice: initialDestinationDevice,
				scenarios: initialScenarios,
				activeScenarioIndex: initialActiveScenarioIndex
			});
		},
		render: function render() {
			return _react2.default.createElement(_Main2.default, { stateManager: this.stateManager, __source: {
					fileName: _jsxFileName,
					lineNumber: 78
				},
				__self: this
			});
		}
	});

/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/Main.js';

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactDom = __webpack_require__(3);

	var _reactSeeds = __webpack_require__(7);

	var _reactSeeds2 = _interopRequireDefault(_reactSeeds);

	var _mobx = __webpack_require__(24);

	var _mobxReact = __webpack_require__(25);

	var _destinations = __webpack_require__(26);

	var _destinations2 = _interopRequireDefault(_destinations);

	var _colors = __webpack_require__(92);

	var colors = _interopRequireWildcard(_colors);

	var _stylers = __webpack_require__(93);

	var stylers = _interopRequireWildcard(_stylers);

	var _Button = __webpack_require__(94);

	var _Button2 = _interopRequireDefault(_Button);

	var _Field = __webpack_require__(96);

	var _Field2 = _interopRequireDefault(_Field);

	var _Choice = __webpack_require__(97);

	var _Choice2 = _interopRequireDefault(_Choice);

	var _IngredientsEditor = __webpack_require__(98);

	var _IngredientsEditor2 = _interopRequireDefault(_IngredientsEditor);

	var _preview = __webpack_require__(101);

	var _preview2 = _interopRequireDefault(_preview);

	var _state = __webpack_require__(105);

	var _state2 = _interopRequireDefault(_state);

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.default = (0, _mobxReact.observer)(_react2.default.createClass({
		getDefaultProps: function getDefaultProps() {
			return {
				showTree: false,
				backgroundColor: '#191919'
			};
		},
		componentWillMount: function componentWillMount() {
			var _this = this;

			this.onSourceChange = (0, _mobx.action)(function (content) {
				_this.props.stateManager.content = content;
			});
			this.onChangeDestination = (0, _mobx.action)(function (newDestinationID) {
				_this.props.stateManager.destinationID = newDestinationID;
			});
			this.onPhoneDestination = (0, _mobx.action)(function () {
				_this.props.stateManager.destinationDevice = 'phone';
			});
			this.onFullDestination = (0, _mobx.action)(function () {
				_this.props.stateManager.destinationDevice = 'full';
			});
		},
		onSetUpMainField: function onSetUpMainField(component) {
			var el = (0, _reactDom.findDOMNode)(component);
			if (el) {
				el.focus();
			}
		},
		onClickDrag: function onClickDrag(_ref) {
			var type = _ref.type,
			    currentTarget = _ref.currentTarget,
			    target = _ref.target,
			    clientX = _ref.clientX;

			if (type == 'mouseup') {
				this.dragging = false;
			} else if (this.dragging || type == 'mousedown') {
				if (type == 'mousemove') {
					currentTarget.scrollLeft += this.mouseX - clientX;
				}

				if (type == 'mouseup') {
					this.dragging = false;
				} else {
					// Only allow clicking on background
					if (target.tagName == 'DIV') {
						this.dragging = true;
						this.mouseX = clientX;
					}
				}
			}
		},
		render: function render() {
			var _props = this.props,
			    showTree = _props.showTree,
			    stateManager = _props.stateManager,
			    backgroundColor = _props.backgroundColor;
			var content = stateManager.content,
			    contentTree = stateManager.contentTree,
			    ingredients = stateManager.ingredients,
			    activeIngredients = stateManager.activeIngredients,
			    scenarios = stateManager.scenarios,
			    activeScenarioIndex = stateManager.activeScenarioIndex,
			    destinationID = stateManager.destinationID,
			    destinationDevice = stateManager.destinationDevice;


			var scenario = scenarios[activeScenarioIndex];

			console.dir(scenario);
			console.dir(contentTree);
			console.dir(activeIngredients);

			return _react2.default.createElement(
				_reactSeeds.Seed,
				{ row: true, justifyContent: 'center',
					grow: 0, shrink: 0,
					background: { color: backgroundColor },
					__source: {
						fileName: _jsxFileName,
						lineNumber: 96
					},
					__self: this
				},
				_react2.default.createElement(
					_reactSeeds.Seed,
					{ row: true,
						grow: 1, shrink: 2,
						minWidth: 320,
						overflow: 'scroll',
						onMouseDown: this.onClickDrag,
						onMouseMove: this.onClickDrag,
						onMouseUp: this.onClickDrag,
						__source: {
							fileName: _jsxFileName,
							lineNumber: 100
						},
						__self: this
					},
					_react2.default.createElement(
						_reactSeeds.Seed,
						_extends({ column: true,
							grow: 1
						}, stylers.mainColumn, {
							__source: {
								fileName: _jsxFileName,
								lineNumber: 108
							},
							__self: this
						}),
						_react2.default.createElement(_Field2.default, _extends({
							ref: this.onSetUpMainField,
							value: content,
							onChange: this.onSourceChange
						}, stylers.sourceField, {
							__source: {
								fileName: _jsxFileName,
								lineNumber: 112
							},
							__self: this
						}))
					),
					_react2.default.createElement(
						_reactSeeds.Seed,
						{ column: true, __source: {
								fileName: _jsxFileName,
								lineNumber: 119
							},
							__self: this
						},
						_react2.default.createElement(_IngredientsEditor2.default, {
							ingredients: ingredients,
							ingredientIDToVariationIndex: scenario,
							onAddNew: stateManager.addNewIngredient,
							onRemoveAtIndex: stateManager.onRemoveIngredientAtIndex,
							onAddVariationAtIndex: stateManager.onAddVariationAtIndex,
							__source: {
								fileName: _jsxFileName,
								lineNumber: 120
							},
							__self: this
						})
					)
				),
				showTree && _react2.default.createElement(
					_reactSeeds.Seed,
					_extends({ row: true, grow: 1, shrink: 1
					}, stylers.preview, {
						__source: {
							fileName: _jsxFileName,
							lineNumber: 130
						},
						__self: this
					}),
					_react2.default.createElement(
						'pre',
						{
							__source: {
								fileName: _jsxFileName,
								lineNumber: 133
							},
							__self: this
						},
						!!contentTree ? JSON.stringify(contentTree, null, 2) : null
					)
				),
				_react2.default.createElement(_preview2.default, {
					contentTree: contentTree,
					ingredients: activeIngredients,
					destinationID: destinationID,
					destinationDevice: destinationDevice,
					destinations: _destinations2.default,
					onChangeDestination: this.onChangeDestination,
					onPhoneDestination: this.onPhoneDestination,
					onFullDestination: this.onFullDestination,
					__source: {
						fileName: _jsxFileName,
						lineNumber: 140
					},
					__self: this
				})
			);
		}
	}));

/***/ },
/* 6 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_6__;

/***/ },
/* 7 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _boxSizing = __webpack_require__(8);

	Object.defineProperty(exports, 'boxSizing', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_boxSizing).default;
	  }
	});

	var _visibility = __webpack_require__(11);

	Object.defineProperty(exports, 'visibility', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_visibility).default;
	  }
	});

	var _flex = __webpack_require__(12);

	Object.defineProperty(exports, 'flex', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_flex).default;
	  }
	});

	var _position = __webpack_require__(13);

	Object.defineProperty(exports, 'position', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_position).default;
	  }
	});

	var _margin = __webpack_require__(14);

	Object.defineProperty(exports, 'margin', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_margin).default;
	  }
	});

	var _padding = __webpack_require__(15);

	Object.defineProperty(exports, 'padding', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_padding).default;
	  }
	});

	var _text = __webpack_require__(16);

	Object.defineProperty(exports, 'text', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_text).default;
	  }
	});

	var _font = __webpack_require__(17);

	Object.defineProperty(exports, 'font', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_font).default;
	  }
	});

	var _background = __webpack_require__(18);

	Object.defineProperty(exports, 'background', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_background).default;
	  }
	});

	var _border = __webpack_require__(19);

	Object.defineProperty(exports, 'border', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_border).default;
	  }
	});

	var _transition = __webpack_require__(20);

	Object.defineProperty(exports, 'transition', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_transition).default;
	  }
	});

	var _all = __webpack_require__(21);

	Object.defineProperty(exports, 'default', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_all).default;
	  }
	});

	var _Seed = __webpack_require__(22);

	Object.defineProperty(exports, 'Seed', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_Seed).default;
	  }
	});

	var _appearanceNone = __webpack_require__(23);

	Object.defineProperty(exports, 'appearanceNone', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_appearanceNone).default;
	  }
	});

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/***/ },
/* 8 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.default = (0, _reactSow2.default)(function (_ref) {
		var _ref$boxSizing = _ref.boxSizing;
		var boxSizing = _ref$boxSizing === undefined ? 'border-box' : _ref$boxSizing;
		var overflow = _ref.overflow;
		var width = _ref.width;
		var height = _ref.height;
		var minWidth = _ref.minWidth;
		var minHeight = _ref.minHeight;
		var maxWidth = _ref.maxWidth;
		var maxHeight = _ref.maxHeight;
		return {
			boxSizing: boxSizing,
			overflow: overflow,
			width: width,
			height: height,
			minWidth: minWidth,
			minHeight: minHeight,
			maxWidth: maxWidth,
			maxHeight: maxHeight
		};
	});
	module.exports = exports['default'];

/***/ },
/* 9 */
/***/ function(module, exports, __webpack_require__) {

	var isFunction = __webpack_require__(10);


	function createStyler(renderStyle) {
		if (!isFunction(renderStyle)) {
			var style = renderStyle;
			renderStyle = function() {
				return style;
			};
		}

		function renderProps(props) {
			props = props || {};
			// Render
			var outputStyle = renderStyle(props);
			// Make copy, with custom props merged
			outputStyle = Object.assign({}, 
				outputStyle,
				props.style
			);
			
			var outputClassName = (props && props.className) || '';
			var children = props.children;
			
			// Use classes, if present
			if (outputStyle.classes) {
				outputStyle.classes.forEach(function(useClass) {
					var className;
					if (typeof useClass === 'string') {
						className = useClass;
					}
					else {
						className = useClass();
					}
					
					outputClassName += ' ' + className;
				});
				
				// Remove from outputted rules
				delete outputStyle.classes;
			}

			if (outputStyle.children) {
				children = outputStyle.children;

				delete outputStyle.children;
			}
			
			// Return output props
			var output = {
				style: outputStyle,
				className: outputClassName.trim()
			};

			if (children) {
				output.children = children;
			}

			return output;
		}

		extendStyler(renderProps);

		return renderProps;
	}

	function sow(renderStyle, children) {
		return Object.assign(
			!!renderStyle.isSow ? (
				renderStyle
			) : (
				createStyler(renderStyle)
			),
			{ isSow: true }
		);
	}

	function combine(stylers) {
		function renderProps(props) {
			// Combine `style` and `classes` props
			return stylers.reduce(function(combined, styler) {
				var output = sow(styler)(props);

				if (output.style) {
					if (output.className) {
						// Concat to existing classes
						combined.className = [combined.className].concat(output.className).join(' ').trim();
					}

					if (output.children) {
						combined.children = output.children; 
					}

					// Merge all style props
					Object.assign(combined.style, output.style);
				}

				return combined;
			}, { style: {}, className: '' });
		};

		extendStyler(renderProps);

		return renderProps;
	}

	function concat(other) {
		return combine([ this, other ]);
	}

	function extendStyler(styler) {
		styler.concat = concat;
	}

	sow.combine = combine;
	module.exports = sow;


/***/ },
/* 10 */
/***/ function(module, exports) {

	/**
	 * lodash 3.0.8 (Custom Build) <https://lodash.com/>
	 * Build: `lodash modularize exports="npm" -o ./`
	 * Copyright 2012-2016 The Dojo Foundation <http://dojofoundation.org/>
	 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
	 * Copyright 2009-2016 Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
	 * Available under MIT license <https://lodash.com/license>
	 */

	/** `Object#toString` result references. */
	var funcTag = '[object Function]',
	    genTag = '[object GeneratorFunction]';

	/** Used for built-in method references. */
	var objectProto = Object.prototype;

	/**
	 * Used to resolve the [`toStringTag`](http://ecma-international.org/ecma-262/6.0/#sec-object.prototype.tostring)
	 * of values.
	 */
	var objectToString = objectProto.toString;

	/**
	 * Checks if `value` is classified as a `Function` object.
	 *
	 * @static
	 * @memberOf _
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is correctly classified, else `false`.
	 * @example
	 *
	 * _.isFunction(_);
	 * // => true
	 *
	 * _.isFunction(/abc/);
	 * // => false
	 */
	function isFunction(value) {
	  // The use of `Object#toString` avoids issues with the `typeof` operator
	  // in Safari 8 which returns 'object' for typed array constructors, and
	  // PhantomJS 1.9 which returns 'function' for `NodeList` instances.
	  var tag = isObject(value) ? objectToString.call(value) : '';
	  return tag == funcTag || tag == genTag;
	}

	/**
	 * Checks if `value` is the [language type](https://es5.github.io/#x8) of `Object`.
	 * (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
	 *
	 * @static
	 * @memberOf _
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
	 * @example
	 *
	 * _.isObject({});
	 * // => true
	 *
	 * _.isObject([1, 2, 3]);
	 * // => true
	 *
	 * _.isObject(_.noop);
	 * // => true
	 *
	 * _.isObject(null);
	 * // => false
	 */
	function isObject(value) {
	  var type = typeof value;
	  return !!value && (type == 'object' || type == 'function');
	}

	module.exports = isFunction;


/***/ },
/* 11 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.default = (0, _reactSow2.default)(function (_ref) {
		var visibility = _ref.visibility;
		var opacity = _ref.opacity;
		return {
			visibility: visibility,
			opacity: opacity
		};
	});
	module.exports = exports['default'];

/***/ },
/* 12 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.default = (0, _reactSow2.default)(function (_ref) {
		var _ref$row = _ref.row;
		var row = _ref$row === undefined ? false : _ref$row;
		var _ref$column = _ref.column;
		var column = _ref$column === undefined ? false : _ref$column;
		var _ref$reverse = _ref.reverse;
		var reverse = _ref$reverse === undefined ? false : _ref$reverse;
		var _ref$wrap = _ref.wrap;
		var wrap = _ref$wrap === undefined ? false : _ref$wrap;
		var alignItems = _ref.alignItems;
		var alignContent = _ref.alignContent;
		var justifyContent = _ref.justifyContent;
		var basis = _ref.basis;
		var grow = _ref.grow;
		var shrink = _ref.shrink;
		var alignSelf = _ref.alignSelf;
		return Object.assign({}, (row || column) && {
			display: 'flex',
			flexDirection: column ? reverse ? 'column-reverse' : 'column' : reverse ? 'row-reverse' : 'row',
			flexWrap: typeof wrap === 'string' ? wrap : wrap ? 'wrap' : 'nowrap'
		}, alignItems != null && { alignItems: alignItems }, alignContent != null && { alignContent: alignContent }, justifyContent != null && { justifyContent: justifyContent }, basis != null && { flexBasis: basis }, grow != null && { flexGrow: grow }, shrink != null && { flexShrink: shrink }, alignSelf != null && { alignSelf: alignSelf });
	});
	module.exports = exports['default'];

/***/ },
/* 13 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function positionElements(_ref) {
		var top = _ref.top;
		var bottom = _ref.bottom;
		var left = _ref.left;
		var right = _ref.right;

		return { top: top, bottom: bottom, left: left, right: right };
	}

	exports.default = (0, _reactSow2.default)(function (_ref2) {
		var _ref2$absolute = _ref2.absolute;
		var absolute = _ref2$absolute === undefined ? false : _ref2$absolute;
		var _ref2$relative = _ref2.relative;
		var relative = _ref2$relative === undefined ? false : _ref2$relative;
		var zIndex = _ref2.zIndex;
		return Object.assign({
			zIndex: zIndex
		}, !!absolute ? Object.assign({ position: 'absolute' }, positionElements(absolute)) : !!relative ? Object.assign({ position: 'relative' }, positionElements(relative)) : null);
	});
	module.exports = exports['default'];

/***/ },
/* 14 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.default = (0, _reactSow2.default)(function (_ref) {
		var margin = _ref.margin;
		return margin == null ? {} : typeof margin === 'number' || typeof margin === 'string' ? { marginTop: margin, marginLeft: margin, marginRight: margin, marginBottom: margin } : Object.assign({}, margin.top != null && { marginTop: margin.top } || margin.base != null && { marginTop: margin.base }, margin.left != null && { marginLeft: margin.left } || margin.base != null && { marginLeft: margin.base }, margin.right != null && { marginRight: margin.right } || margin.base != null && { marginRight: margin.base }, margin.bottom != null && { marginBottom: margin.bottom } || margin.base != null && { marginBottom: margin.base });
	});
	module.exports = exports['default'];

/***/ },
/* 15 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.default = (0, _reactSow2.default)(function (_ref) {
		var padding = _ref.padding;
		return padding == null ? {} : typeof padding === 'number' || typeof padding === 'string' ? { paddingTop: padding, paddingLeft: padding, paddingRight: padding, paddingBottom: padding } : Object.assign({}, padding.top != null && { paddingTop: padding.top } || padding.base != null && { paddingTop: padding.base }, padding.left != null && { paddingLeft: padding.left } || padding.base != null && { paddingLeft: padding.base }, padding.right != null && { paddingRight: padding.right } || padding.base != null && { paddingRight: padding.base }, padding.bottom != null && { paddingBottom: padding.bottom } || padding.base != null && { paddingBottom: padding.base });
	});
	module.exports = exports['default'];

/***/ },
/* 16 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.default = (0, _reactSow2.default)(function (_ref) {
		var text = _ref.text;
		return !!text ? Object.assign({}, text.color != null && { color: text.color }, text.align != null && { textAlign: text.align }, text.lineHeight != null && { lineHeight: text.lineHeight }, text.indent != null && { textIndent: text.indent }, text.overflow != null && { textOverflow: text.overflow }, text.transform != null && { textTransform: text.transform }, text.decoration != null && { textDecoration: text.decoration }, text.shadow != null && { textShadow: text.shadow }, text.rendering != null && { textRendering: text.rendering }, text.whitespace != null && { whiteSpace: text.whitespace }) : {};
	});
	module.exports = exports['default'];

/***/ },
/* 17 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.default = (0, _reactSow2.default)(function (_ref) {
		var font = _ref.font;
		return !!font ? Object.assign({}, font.family != null && { fontFamily: font.family }, font.size != null && { fontSize: font.size }, font.weight != null && { fontWeight: font.weight }, font.style != null && { fontStyle: font.style }, font.stretch != null && { fontStretch: font.stretch }, font.variant != null && { fontVariant: font.variant }, font.kerning != null && { fontKerning: font.kerning }) : {};
	});
	module.exports = exports['default'];

/***/ },
/* 18 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.default = (0, _reactSow2.default)(function (_ref) {
		var background = _ref.background;
		return !!background ? typeof background === 'string' ? { background: background } : Object.assign({}, background.color != null && { backgroundColor: background.color }, background.image != null && { backgroundImage: background.image }, background.position != null && { backgroundPosition: background.position }, background.size != null && { backgroundSize: background.size }, background.origin != null && { backgroundOrigin: background.origin }, background.clip != null && { backgroundClip: background.clip }, background.repeat != null && {
			backgroundRepeat: background.repeat === false ? 'no-repeat' : background.repeat === true ? 'repeat' : background.repeat
		}, background.attachment != null && { backgroundAttachment: background.attachment }) : {};
	});
	module.exports = exports['default'];

/***/ },
/* 19 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	module.exports = (0, _reactSow2.default)(function (_ref) {
		var borderRadius = _ref.borderRadius;
		var cornerRadius = _ref.cornerRadius;
		var border = _ref.border;
		var boxShadow = _ref.boxShadow;
		return Object.assign({}, borderRadius != null && { borderRadius: borderRadius }, cornerRadius != null && { borderRadius: cornerRadius }, border != null && (typeof border === 'string' ? { border: border } : Object.assign({}, border.width != null && { borderWidth: border.width }, border.style != null && { borderStyle: border.style }, border.color != null && { borderColor: border.color })), boxShadow != null && { boxShadow: boxShadow });
	});

/***/ },
/* 20 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var defaultTransitionAll = 'all 0.3s ease-in-out';

	var addPrefixes = function addPrefixes(transition) {
		return {
			transition: transition,
			WebkitTransition: transition,
			msTransition: transition
		};
	};

	exports.default = (0, _reactSow2.default)(function (_ref) {
		var _ref$transitionAll = _ref.transitionAll;
		var transitionAll = _ref$transitionAll === undefined ? false : _ref$transitionAll;
		return Object.assign({}, transitionAll && addPrefixes(transitionAll));
	});
	module.exports = exports['default'];

/***/ },
/* 21 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	var _boxSizing = __webpack_require__(8);

	var _boxSizing2 = _interopRequireDefault(_boxSizing);

	var _visibility = __webpack_require__(11);

	var _visibility2 = _interopRequireDefault(_visibility);

	var _flex = __webpack_require__(12);

	var _flex2 = _interopRequireDefault(_flex);

	var _position = __webpack_require__(13);

	var _position2 = _interopRequireDefault(_position);

	var _margin = __webpack_require__(14);

	var _margin2 = _interopRequireDefault(_margin);

	var _padding = __webpack_require__(15);

	var _padding2 = _interopRequireDefault(_padding);

	var _text = __webpack_require__(16);

	var _text2 = _interopRequireDefault(_text);

	var _font = __webpack_require__(17);

	var _font2 = _interopRequireDefault(_font);

	var _background = __webpack_require__(18);

	var _background2 = _interopRequireDefault(_background);

	var _border = __webpack_require__(19);

	var _border2 = _interopRequireDefault(_border);

	var _transition = __webpack_require__(20);

	var _transition2 = _interopRequireDefault(_transition);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.default = _reactSow2.default.combine([_boxSizing2.default, _visibility2.default, _flex2.default, _position2.default, _margin2.default, _padding2.default, _text2.default, _font2.default, _background2.default, _border2.default, _transition2.default]);
	module.exports = exports['default'];

/***/ },
/* 22 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _all = __webpack_require__(21);

	var _all2 = _interopRequireDefault(_all);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

	var handlerKeyRegex = /^on[A-Z0-9]/;

	// Pick props matching with on- prefix
	function pickHandlers(props) {
		return Object.keys(props).reduce(function (picked, key) {
			if (handlerKeyRegex.test(key)) {
				picked[key] = props[key];
			}
			return picked;
		}, {});
	}

	var defaultStyler = function defaultStyler() {
		return {};
	};

	exports.default = _react2.default.createClass({
		displayName: 'Seed',

		render: function render() {
			var _props = this.props;
			var _props$Component = _props.Component;
			var Component = _props$Component === undefined ? 'div' : _props$Component;
			var className = _props.className;
			var _props$styler = _props.styler;
			var styler = _props$styler === undefined ? defaultStyler : _props$styler;

			var rest = _objectWithoutProperties(_props, ['Component', 'className', 'styler']);

			// Keep these props in rest, for `styler` to use


			var value = rest.value;
			var checked = rest.checked;
			var selected = rest.selected;
			var href = rest.href;

			// `children` gets handled automatically by styler

			return _react2.default.createElement(Component, _extends({}, pickHandlers(rest), (0, _all2.default)(rest), {
				className: className,
				value: value,
				checked: checked,
				selected: selected,
				href: href
			}, styler(rest)));
		}
	});
	module.exports = exports['default'];

/***/ },
/* 23 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.default = (0, _reactSow2.default)({
		WebkitAppearance: 'none',
		MozAppearance: 'none',
		msAppearance: 'none',
		appearance: 'none'
	});
	module.exports = exports['default'];

/***/ },
/* 24 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_24__;

/***/ },
/* 25 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_25__;

/***/ },
/* 26 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _Piping = __webpack_require__(27);

	var piping = _interopRequireWildcard(_Piping);

	var _Vanilla = __webpack_require__(48);

	var vanilla = _interopRequireWildcard(_Vanilla);

	var _Bootstrap = __webpack_require__(85);

	var bootstrap = _interopRequireWildcard(_Bootstrap);

	var _Foundation = __webpack_require__(87);

	var foundation = _interopRequireWildcard(_Foundation);

	var _AcceleratedMobilePages = __webpack_require__(88);

	var acceleratedMobilePages = _interopRequireWildcard(_AcceleratedMobilePages);

	var _ReactCode = __webpack_require__(89);

	var reactCode = _interopRequireWildcard(_ReactCode);

	var _Records = __webpack_require__(90);

	var records = _interopRequireWildcard(_Records);

	var _Raw = __webpack_require__(91);

	var raw = _interopRequireWildcard(_Raw);

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

	//import * as slides from './Slides'

	// Web
	exports.default = { piping: piping, vanilla: vanilla, bootstrap: bootstrap, foundation: foundation, reactCode: reactCode, records: records, raw: raw };

	// Code

/***/ },
/* 27 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.title = exports.Preview = undefined;

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/destinations/Piping.js';
	exports.head = head;

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactSeeds = __webpack_require__(7);

	var _reactSeeds2 = _interopRequireDefault(_reactSeeds);

	var _rgba = __webpack_require__(28);

	var _rgba2 = _interopRequireDefault(_rgba);

	var _ios = __webpack_require__(29);

	var Piping = _interopRequireWildcard(_ios);

	var _Vanilla = __webpack_require__(48);

	var Vanilla = _interopRequireWildcard(_Vanilla);

	var _Message = __webpack_require__(81);

	var Message = _interopRequireWildcard(_Message);

	var _render = __webpack_require__(73);

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var tone1 = _rgba2.default.whiteValue(200, 1.0);
	var tone2 = _rgba2.default.whiteValue(140, 1.0);

	var button = function button(tags, mentions, texts) {
		return _react2.default.createElement(_reactSeeds.Seed, { children: texts,
			alignSelf: 'center',
			padding: { top: 6, bottom: 6, left: 8, right: 8 },
			margin: { bottom: '0.5em' },
			text: { align: 'center' },
			font: { size: _ramda2.default.has('large', tags) ? 20 : _ramda2.default.has('small', tags) ? 12 : 16 },
			background: { color: tone1 },
			cornerRadius: 2,
			__source: {
				fileName: _jsxFileName,
				lineNumber: 15
			},
			__self: undefined
		});
	};

	var field = function field(tags, mentions, texts, children, Element, resolveContent) {
		return _react2.default.createElement(
			_reactSeeds.Seed,
			{ column: true,
				grow: 1, alignSelf: 'center', minWidth: '12em',
				margin: { bottom: '1em' },
				__source: {
					fileName: _jsxFileName,
					lineNumber: 27
				},
				__self: undefined
			},
			_react2.default.createElement(_reactSeeds.Seed, { children: texts, __source: {
					fileName: _jsxFileName,
					lineNumber: 31
				},
				__self: undefined
			}),
			_react2.default.createElement(_reactSeeds.Seed, {
				grow: 1,
				minHeight: '1.4em',
				padding: '0.25em',
				border: { width: 1, style: 'solid', color: tone2 },
				children: resolveContent(tags.value),
				__source: {
					fileName: _jsxFileName,
					lineNumber: 32
				},
				__self: undefined
			})
		);
	};

	var textStyler = function textStyler(_ref) {
		var link = _ref.link,
		    _ref$small = _ref.small,
		    small = _ref$small === undefined ? false : _ref$small;
		return (0, _reactSeeds2.default)({
			text: { decoration: _ramda2.default.isNil(link) ? 'none' : 'underline' },
			font: { size: small ? 12 : null }
		});
	};

	var text = function text(tags, mentions, texts, children, Element, resolveContent) {
		var _ref2 = _ramda2.default.has('primary', tags) ? ['h1', '2em', 'center'] : _ramda2.default.has('secondary', tags) ? ['h2', '1.5em', 'center'] : _ramda2.default.has('tertiary', tags) ? ['h3', '1.25em', 'center'] : ['p', '1em', 'left'],
		    Component = _ref2[0],
		    fontSize = _ref2[1],
		    textAlign = _ref2[2];

		return _react2.default.createElement(_reactSeeds.Seed, _extends({ Component: Component,
			maxWidth: '30rem',
			alignSelf: 'center',
			text: { align: textAlign },
			font: { size: fontSize },
			children: resolveContent({ mentions: mentions, texts: texts })
		}, textStyler(tags), {
			__source: {
				fileName: _jsxFileName,
				lineNumber: 61
			},
			__self: undefined
		}));
	};

	var elementRendererForTags = Message.useWithFallback(_ramda2.default.cond([[_ramda2.default.has('button'), _ramda2.default.curry(button)],
	// [ R.has('cta'), R.curry(Vanilla.cta) ],
	[_ramda2.default.has('choice'), _ramda2.default.curry(button)], [_ramda2.default.has('field'), _ramda2.default.curry(field)], [_ramda2.default.has('image'), _ramda2.default.curry(Vanilla.placeholderImage)], [_ramda2.default.has('video'), _ramda2.default.curry(Vanilla.video)], [_ramda2.default.has('text'), _ramda2.default.curry(text)],
	// [ R.has('swatch'), R.curry(Vanilla.swatch) ],
	// [ R.has('nav'), R.curry(Vanilla.nav) ],
	// [ R.has('columns'), R.curry(Vanilla.columns) ],
	// [ R.has('list'), R.curry(Vanilla.list) ],
	[_ramda2.default.T, _ramda2.default.curry(text)]]));

	var Preview = exports.Preview = _ramda2.default.pipe((0, _render.renderTreeUsing)({
		elementRendererForTags: elementRendererForTags
	}));

	var title = exports.title = 'Piping Wireframes';

	function head() {
		return [_react2.default.createElement('style', { children: '\nhtml {\n\theight: 100%;\n\tbackground-color: #fdfdfd;\n}\nhtml, h1, input, button {\n\tfont-family: \'Lato\', sans-serif;\n}\nbody {\n\theight: 100%;\n\tmargin: 0;\n}\n\n* {\n\tbox-sizing: border-box;\n\tmargin: 0;\n\tpadding: 0;\n}\n', __source: {
				fileName: _jsxFileName,
				lineNumber: 97
			},
			__self: this
		})];
	}

/***/ },
/* 28 */
/***/ function(module, exports) {

	function RGBA(r, g, b, a) {
		this.r = r;
		this.g = g;
		this.b = b;
		this.a = (typeof a === 'undefined' ? 1 : a);
	}

	RGBA.prototype.get = function(key) {
		return this[key]
	}

	RGBA.prototype.mapRGB = function(mapper) {
		return new RGBA(
			mapper(this.r, 'r'),
			mapper(this.g, 'g'),
			mapper(this.b, 'b'),
			this.a
		)
	}

	RGBA.prototype.mapAlpha = function(mapper) {
		return new RGBA(
			this.r,
			this.g,
			this.b,
			mapper(this.a)
		)
	}

	// Used by React to automatically convert to a string
	RGBA.prototype.toString = function() {
		return 'rgba(' + [this.r, this.g, this.b, this.a].join(',') + ')';
	};

	// We want the underlying RGBA type to be an implementation detail
	function rgba(r, g, b, a) {
		return new RGBA(r, g, b, a);
	}

	function whiteValue(whiteAmount, a) {
		return new RGBA(whiteAmount, whiteAmount, whiteAmount, a);
	}

	rgba.whiteValue = whiteValue;
	module.exports = rgba; 

/***/ },
/* 29 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, '__esModule', {
	  value: true
	});

	function _interopRequire(obj) { return obj && obj.__esModule ? obj['default'] : obj; }

	var _componentsButton = __webpack_require__(30);

	exports.button = _interopRequire(_componentsButton);

	var _componentsText = __webpack_require__(42);

	exports.text = _interopRequire(_componentsText);

	var _componentsTable = __webpack_require__(43);

	exports.table = _interopRequire(_componentsTable);
	Object.defineProperty(exports, 'tableCell', {
	  enumerable: true,
	  get: function get() {
	    return _componentsTable.TableCell;
	  }
	});

	var _componentsCollection = __webpack_require__(45);

	exports.collection = _interopRequire(_componentsCollection);

	var _componentsTabs = __webpack_require__(46);

	exports.tabs = _interopRequire(_componentsTabs);

	var _componentsAlert = __webpack_require__(47);

	exports.alert = _interopRequire(_componentsAlert);

/***/ },
/* 30 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, '__esModule', {
		value: true
	});

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	exports['default'] = Button;

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _Box = __webpack_require__(31);

	var _Box2 = _interopRequireDefault(_Box);

	var _Text = __webpack_require__(42);

	var _Text2 = _interopRequireDefault(_Text);

	function Button(_ref) {
		var title = _ref.title;
		var _ref$enabled = _ref.enabled;
		var enabled = _ref$enabled === undefined ? true : _ref$enabled;
		var _ref$align = _ref.align;
		var align = _ref$align === undefined ? 'center' : _ref$align;
		var _ref$size = _ref.size;
		var size = _ref$size === undefined ? 17 : _ref$size;
		var fontWeight = _ref.fontWeight;
		var _ref$outline = _ref.outline;
		var outline = _ref$outline === undefined ? true : _ref$outline;
		var _ref$big = _ref.big;
		var big = _ref$big === undefined ? false : _ref$big;

		var boxProps = _objectWithoutProperties(_ref, ['title', 'enabled', 'align', 'size', 'fontWeight', 'outline', 'big']);

		var extraProps = {};
		if (big) {
			extraProps.padding = 20;
			extraProps.cornerRadius = 12.5;
			size = 20;
		}

		return _react2['default'].createElement(
			_Box2['default'],
			_extends({ outline: outline }, extraProps, boxProps),
			_react2['default'].createElement(
				_Text2['default'],
				{ enabled: enabled, align: align, size: size, fontWeight: fontWeight },
				title
			)
		);
	}

	module.exports = exports['default'];

/***/ },
/* 31 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, '__esModule', {
		value: true
	});
	exports['default'] = Box;

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	var _stylers = __webpack_require__(32);

	var stylers = _interopRequireWildcard(_stylers);

	var outlineStyler = (0, _reactSow2['default'])(function (_ref) {
		var _ref$outline = _ref.outline;
		var outline = _ref$outline === undefined ? false : _ref$outline;
		var _ref$outlineWidth = _ref.outlineWidth;
		var outlineWidth = _ref$outlineWidth === undefined ? 1 : _ref$outlineWidth;
		return Object.assign({}, outline ? { boxShadow: 'inset 0 0 ' + outlineWidth + 'px #111' } : {});
	});

	var backgroundStyler = (0, _reactSow2['default'])(function (_ref2) {
		var backgroundColor = _ref2.backgroundColor;
		return Object.assign({}, backgroundColor ? { backgroundColor: backgroundColor } : {});
	});

	var styler = _reactSow2['default'].combine([stylers.boxSizing, stylers.flex, stylers.position, stylers.margin, stylers.padding, stylers.corner, stylers.transition, outlineStyler, backgroundStyler]);

	function Box(_ref3) {
		var children = _ref3.children;
		var url = _ref3.url;

		var stylerProps = _objectWithoutProperties(_ref3, ['children', 'url']);

		var element = _react2['default'].createElement(
			'div',
			styler(stylerProps),
			children
		);

		if (url) {
			element = _react2['default'].createElement(
				'a',
				{ href: url },
				element
			);
		}

		return element;
	}

	module.exports = exports['default'];

/***/ },
/* 32 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, '__esModule', {
	  value: true
	});

	function _interopRequire(obj) { return obj && obj.__esModule ? obj['default'] : obj; }

	var _boxSizing = __webpack_require__(33);

	exports.boxSizing = _interopRequire(_boxSizing);

	var _visibility = __webpack_require__(34);

	exports.visibility = _interopRequire(_visibility);

	var _flex = __webpack_require__(35);

	exports.flex = _interopRequire(_flex);

	var _position = __webpack_require__(36);

	exports.position = _interopRequire(_position);

	var _margin = __webpack_require__(37);

	exports.margin = _interopRequire(_margin);

	var _padding = __webpack_require__(38);

	exports.padding = _interopRequire(_padding);

	var _corner = __webpack_require__(39);

	exports.corner = _interopRequire(_corner);

	var _transition = __webpack_require__(40);

	exports.transition = _interopRequire(_transition);

	var _dark = __webpack_require__(41);

	exports.dark = _interopRequire(_dark);

/***/ },
/* 33 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, '__esModule', {
		value: true
	});

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	exports['default'] = (0, _reactSow2['default'])(function (_ref) {
		var _ref$boxSizing = _ref.boxSizing;
		var boxSizing = _ref$boxSizing === undefined ? 'border-box' : _ref$boxSizing;
		var overflow = _ref.overflow;
		var width = _ref.width;
		var height = _ref.height;
		var minWidth = _ref.minWidth;
		var minHeight = _ref.minHeight;
		return Object.assign({
			boxSizing: boxSizing,
			overflow: overflow,
			width: width,
			height: height,
			minWidth: minWidth,
			minHeight: minHeight
		});
	});
	module.exports = exports['default'];

/***/ },
/* 34 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, '__esModule', {
		value: true
	});

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	exports['default'] = (0, _reactSow2['default'])(function (_ref) {
		var visibility = _ref.visibility;
		var opacity = _ref.opacity;
		return {
			visibility: visibility,
			opacity: opacity
		};
	});
	module.exports = exports['default'];

/***/ },
/* 35 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, '__esModule', {
		value: true
	});

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	exports['default'] = (0, _reactSow2['default'])(function (_ref) {
		var _ref$row = _ref.row;
		var row = _ref$row === undefined ? false : _ref$row;
		var _ref$column = _ref.column;
		var column = _ref$column === undefined ? false : _ref$column;
		var _ref$wrap = _ref.wrap;
		var wrap = _ref$wrap === undefined ? false : _ref$wrap;
		var _ref$reverse = _ref.reverse;
		var reverse = _ref$reverse === undefined ? false : _ref$reverse;
		var alignItems = _ref.alignItems;
		var basis = _ref.basis;
		var grow = _ref.grow;
		var shrink = _ref.shrink;
		var width = _ref.width;
		var height = _ref.height;
		return Object.assign({}, (row || column) && { display: 'flex', flexDirection: column ? reverse ? 'column-reverse' : 'column' : reverse ? 'row-reverse' : 'row' }, { flexWrap: wrap ? 'wrap' : 'nowrap' }, alignItems && { alignItems: alignItems }, basis != null && { flexBasis: basis }, grow != null && { flexGrow: grow }, shrink != null && { flexShrink: shrink }, width != null && { width: width }, height != null && { height: height });
	});

	/*export default sow(({ flex = false, basis, grow, shrink }) => [
		flex && { display: 'flex' },
		basis && { flexBasis: basis },
		grow && { flexGrow: grow },
		shrink && { flexShrink: shrink }
	])*/
	module.exports = exports['default'];

/***/ },
/* 36 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, '__esModule', {
		value: true
	});

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	function positionElements(_ref) {
		var top = _ref.top;
		var bottom = _ref.bottom;
		var left = _ref.left;
		var right = _ref.right;

		return { top: top, bottom: bottom, left: left, right: right };
	}

	exports['default'] = (0, _reactSow2['default'])(function (_ref2) {
		var _ref2$absolute = _ref2.absolute;
		var absolute = _ref2$absolute === undefined ? false : _ref2$absolute;
		var _ref2$relative = _ref2.relative;
		var relative = _ref2$relative === undefined ? false : _ref2$relative;
		var zIndex = _ref2.zIndex;
		return Object.assign({
			zIndex: zIndex
		}, !!absolute ? Object.assign({ position: 'absolute' }, positionElements(absolute)) : !!relative ? Object.assign({ position: 'relative' }, positionElements(relative)) : null);
	});
	module.exports = exports['default'];

/***/ },
/* 37 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, '__esModule', {
		value: true
	});

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	exports['default'] = (0, _reactSow2['default'])(function (_ref) {
		var margin = _ref.margin;
		return margin == null ? {} : typeof margin === 'number' ? { margin: margin } : Object.assign({}, margin.top != null && { marginTop: margin.top }, margin.left != null && { marginLeft: margin.left }, margin.right != null && { marginRight: margin.right }, margin.bottom != null && { marginBottom: margin.bottom });
	});
	module.exports = exports['default'];

/***/ },
/* 38 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, '__esModule', {
		value: true
	});

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	exports['default'] = (0, _reactSow2['default'])(function (_ref) {
		var padding = _ref.padding;
		return padding == null ? {} : typeof padding === 'number' ? { padding: padding } : Object.assign({}, padding.top != null && { paddingTop: padding.top }, padding.left != null && { paddingLeft: padding.left }, padding.right != null && { paddingRight: padding.right }, padding.bottom != null && { paddingBottom: padding.bottom });
	});
	module.exports = exports['default'];

/***/ },
/* 39 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, '__esModule', {
		value: true
	});

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	exports['default'] = (0, _reactSow2['default'])(function (_ref) {
		var cornerRadius = _ref.cornerRadius;
		return {
			borderRadius: cornerRadius
		};
	});
	module.exports = exports['default'];

/***/ },
/* 40 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, '__esModule', {
		value: true
	});

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	var defaultTransitionAll = 'all 0.3s ease-in-out';

	exports['default'] = (0, _reactSow2['default'])(function (_ref) {
		var _ref$transitionAll = _ref.transitionAll;
		var transitionAll = _ref$transitionAll === undefined ? false : _ref$transitionAll;
		return Object.assign({}, transitionAll && { transition: defaultTransitionAll, WebkitTransition: defaultTransitionAll, msTransition: defaultTransitionAll });
	});
	module.exports = exports['default'];

/***/ },
/* 41 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, '__esModule', {
		value: true
	});

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	var spacing = 10;
	var backgroundColor = '#111';
	var color = '#ee';

	var box = (0, _reactSow2['default'])(function (_ref) {
		var _ref$border = _ref.border;
		var border = _ref$border === undefined ? true : _ref$border;
		return {
			padding: spacing,
			backgroundColor: backgroundColor,
			borderColor: color,
			borderWidth: 1,
			borderStyle: 'solid'
		};
	});

	exports.box = box;
	var text = (0, _reactSow2['default'])({});

	exports.text = text;
	var wrapper = box;
	exports.wrapper = wrapper;

/***/ },
/* 42 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, '__esModule', {
		value: true
	});

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	exports['default'] = Text;

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactSow = __webpack_require__(9);

	var _reactSow2 = _interopRequireDefault(_reactSow);

	var _stylers = __webpack_require__(32);

	var stylers = _interopRequireWildcard(_stylers);

	var textStyler = (0, _reactSow2['default'])(function (_ref) {
		var textAlign = _ref.textAlign;
		var fontFamily = _ref.fontFamily;
		var fontSize = _ref.fontSize;
		var lineHeight = _ref.lineHeight;
		var fontWeight = _ref.fontWeight;
		var _ref$enabled = _ref.enabled;
		var enabled = _ref$enabled === undefined ? true : _ref$enabled;
		return {
			textAlign: textAlign,
			fontFamily: fontFamily,
			fontSize: fontSize,
			lineHeight: lineHeight,
			fontWeight: fontWeight,
			opacity: enabled ? 1.0 : 0.5
		};
	});

	var styler = _reactSow2['default'].combine([textStyler, stylers.boxSizing, stylers.flex, stylers.margin, stylers.padding, stylers.visibility]);

	var appleFontFamily = 'SF UI Display, sans-serif';

	function Text(_ref2) {
		var children = _ref2.children;
		var align = _ref2.align;
		var size = _ref2.size;
		var _ref2$fontFamily = _ref2.fontFamily;
		var fontFamily = _ref2$fontFamily === undefined ? appleFontFamily : _ref2$fontFamily;

		var stylerProps = _objectWithoutProperties(_ref2, ['children', 'align', 'size', 'fontFamily']);

		return _react2['default'].createElement(
			'div',
			styler(_extends({}, stylerProps, { textAlign: align, fontSize: size, fontFamily: fontFamily })),
			children
		);
	}

	module.exports = exports['default'];

/***/ },
/* 43 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, '__esModule', {
		value: true
	});

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	exports['default'] = Table;
	exports.TableCell = TableCell;

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _Box = __webpack_require__(31);

	var _Box2 = _interopRequireDefault(_Box);

	var _Scrollable = __webpack_require__(44);

	var _Scrollable2 = _interopRequireDefault(_Scrollable);

	var _Text = __webpack_require__(42);

	var _Text2 = _interopRequireDefault(_Text);

	function Table(_ref) {
		var items = _ref.items;
		var _ref$showIcons = _ref.showIcons;
		var showIcons = _ref$showIcons === undefined ? true : _ref$showIcons;

		return _react2['default'].createElement(
			_Box2['default'],
			{ column: true, grow: 1 },
			_react2['default'].createElement(
				_Scrollable2['default'],
				null,
				items.map(function (item, index) {
					return _react2['default'].createElement(TableCell, _extends({ key: index }, item, { showIcon: showIcons }));
				})
			)
		);
	}

	function TableCell(_ref2) {
		var text = _ref2.text;
		var detailText = _ref2.detailText;
		var showIcon = _ref2.showIcon;

		return _react2['default'].createElement(
			_Box2['default'],
			{ row: true, height: 49, alignItems: 'center' },
			showIcon && _react2['default'].createElement(_Box2['default'], { width: 30, height: 30, margin: { left: 24, right: 24 }, backgroundColor: '#555' }),
			_react2['default'].createElement(
				_Box2['default'],
				{ column: true },
				_react2['default'].createElement(
					_Text2['default'],
					{ size: 16 },
					text
				),
				detailText && _react2['default'].createElement(
					_Text2['default'],
					{ size: 12 },
					detailText
				)
			)
		);
	}

/***/ },
/* 44 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, '__esModule', {
		value: true
	});
	exports['default'] = Scrollable;

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _Box = __webpack_require__(31);

	var _Box2 = _interopRequireDefault(_Box);

	var _Text = __webpack_require__(42);

	var _Text2 = _interopRequireDefault(_Text);

	function Scrollable(_ref) {
		var children = _ref.children;

		return _react2['default'].createElement(
			'div',
			{ style: { overflow: 'auto', flexGrow: 1 } },
			children
		);
	}

	module.exports = exports['default'];

/***/ },
/* 45 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, '__esModule', {
		value: true
	});

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	exports['default'] = Collection;

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _Box = __webpack_require__(31);

	var _Box2 = _interopRequireDefault(_Box);

	var _Scrollable = __webpack_require__(44);

	var _Scrollable2 = _interopRequireDefault(_Scrollable);

	var _Text = __webpack_require__(42);

	var _Text2 = _interopRequireDefault(_Text);

	var gutter = 2.0;

	function Collection(_ref) {
		var groups = _ref.groups;

		return _react2['default'].createElement(
			_Box2['default'],
			{ column: true, grow: 1 },
			_react2['default'].createElement(
				_Scrollable2['default'],
				null,
				groups.map(function (group, index) {
					return _react2['default'].createElement(CollectionGroup, _extends({ key: index }, group));
				})
			)
		);
	}

	function CollectionGroup(_ref2) {
		var items = _ref2.items;
		var _ref2$itemsPerRow = _ref2.itemsPerRow;
		var itemsPerRow = _ref2$itemsPerRow === undefined ? 4 : _ref2$itemsPerRow;
		var title = _ref2.title;

		return _react2['default'].createElement(
			_Box2['default'],
			{ column: true, margin: { top: 24, bottom: gutter * 2 } },
			title && _react2['default'].createElement(
				_Text2['default'],
				{ margin: { left: 12, bottom: 12 } },
				title
			),
			_react2['default'].createElement(
				_Box2['default'],
				{ row: true, wrap: true, alignItems: 'flex-start', margin: -gutter },
				items.map(function (item, index) {
					return _react2['default'].createElement(CollectionCell, _extends({ key: index
					}, item, {
						span: 1.0 / itemsPerRow
					}));
				})
			)
		);
	}

	function CollectionCell(_ref3) {
		var span = _ref3.span;
		var _ref3$backgroundColor = _ref3.backgroundColor;
		var backgroundColor = _ref3$backgroundColor === undefined ? '#555' : _ref3$backgroundColor;

		return _react2['default'].createElement(
			_Box2['default'],
			{ width: span * 100 + '%', padding: gutter },
			_react2['default'].createElement(_Box2['default'], { padding: { bottom: '100%' }, backgroundColor: backgroundColor })
		);
	}
	module.exports = exports['default'];

/***/ },
/* 46 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, '__esModule', {
		value: true
	});

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	exports['default'] = Tab;

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _Box = __webpack_require__(31);

	var _Box2 = _interopRequireDefault(_Box);

	var _Text = __webpack_require__(42);

	var _Text2 = _interopRequireDefault(_Text);

	var height = 49;

	function Tab(_ref) {
		var items = _ref.items;
		var _ref$showIcons = _ref.showIcons;
		var showIcons = _ref$showIcons === undefined ? true : _ref$showIcons;

		return _react2['default'].createElement(
			_Box2['default'],
			{ row: true, outline: true, shrink: 0 },
			items.map(function (item, index) {
				return _react2['default'].createElement(TabItem, _extends({ key: index }, item, { showIcon: showIcons }));
			})
		);
	}

	var iconInset = 5;

	var Icon = function Icon(_ref2) {
		var selected = _ref2.selected;
		return _react2['default'].createElement(_Box2['default'], { margin: iconInset, width: 34 - iconInset * 2, height: 34 - iconInset * 2, outline: !selected, backgroundColor: selected ? '#555' : null, cornerRadius: '50%' });
	};

	var selectedIcon = Icon({ selected: true });
	var nonselectedIcon = Icon({ selected: false });

	function TabItem(_ref3) {
		var title = _ref3.title;
		var url = _ref3.url;
		var selected = _ref3.selected;
		var showIcon = _ref3.showIcon;

		return _react2['default'].createElement(
			_Box2['default'],
			{ url: url, column: true, alignItems: 'center', grow: 1, height: height },
			showIcon && (selected ? selectedIcon : nonselectedIcon),
			_react2['default'].createElement(
				_Text2['default'],
				{ align: 'center', size: 10 },
				title
			)
		);
	}
	module.exports = exports['default'];

/***/ },
/* 47 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, '__esModule', {
		value: true
	});
	exports['default'] = Alert;

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactSowRgba = __webpack_require__(28);

	var _reactSowRgba2 = _interopRequireDefault(_reactSowRgba);

	var _Box = __webpack_require__(31);

	var _Box2 = _interopRequireDefault(_Box);

	var _Text = __webpack_require__(42);

	var _Text2 = _interopRequireDefault(_Text);

	var _Button = __webpack_require__(30);

	var _Button2 = _interopRequireDefault(_Button);

	function TextBlock(_ref) {
		var title = _ref.title;
		var message = _ref.message;
		var trailingElement = _ref.trailingElement;

		return _react2['default'].createElement(
			_Box2['default'],
			{ column: true, grow: 1, padding: 20 },
			_react2['default'].createElement(
				_Text2['default'],
				{ align: 'center', size: 17, fontWeight: 500, lineHeight: 1.4 },
				title
			),
			_react2['default'].createElement(
				_Text2['default'],
				{ align: 'center', size: 13, lineHeight: 1.3 },
				message
			),
			trailingElement
		);
	}

	function ButtonsList(_ref2) {
		var actions = _ref2.actions;
		var reverse = _ref2.reverse;
		var _ref2$big = _ref2.big;
		var big = _ref2$big === undefined ? false : _ref2$big;
		var _ref2$allowColumn = _ref2.allowColumn;
		var allowColumn = _ref2$allowColumn === undefined ? false : _ref2$allowColumn;

		var actionCount = actions.length;
		var buttonFlexBasis = allowColumn && actionCount <= 2 ? 1.0 / actionCount + '%' : 'auto';

		var buttonElements = actions.map(function (_ref3, index) {
			var title = _ref3.title;
			var _ref3$enabled = _ref3.enabled;
			var enabled = _ref3$enabled === undefined ? true : _ref3$enabled;
			var _ref3$preferred = _ref3.preferred;
			var preferred = _ref3$preferred === undefined ? false : _ref3$preferred;
			return _react2['default'].createElement(_Button2['default'], { key: index,
				title: title,
				enabled: enabled,
				big: big,
				cornerRadius: 0,
				fontWeight: preferred ? 500 : 400,
				grow: 1,
				basis: buttonFlexBasis,
				align: 'center',
				padding: { top: 13, bottom: 13, left: 8, right: 8 }
			});
		});

		return allowColumn && actionCount <= 2 ? _react2['default'].createElement(_Box2['default'], { row: true, shrink: 0, reverse: reverse, children: buttonElements }) : _react2['default'].createElement(_Box2['default'], { column: true, shrink: 0, reverse: reverse, children: buttonElements });
	}

	function ActionSheetBlock(_ref4) {
		var title = _ref4.title;
		var message = _ref4.message;
		var actions = _ref4.actions;
		var _ref4$reverseActions = _ref4.reverseActions;
		var reverseActions = _ref4$reverseActions === undefined ? false : _ref4$reverseActions;

		return _react2['default'].createElement(
			_Box2['default'],
			{ column: true, outline: true, grow: 1, margin: 5, overflow: 'hidden', backgroundColor: _reactSowRgba2['default'].whiteValue(255, 0.94), cornerRadius: 12 },
			(title || message) && _react2['default'].createElement(TextBlock, { title: title, message: message }),
			_react2['default'].createElement(ButtonsList, { big: true, actions: actions, reverse: reverseActions })
		);
	}

	function ActionSheetBody(_ref5) {
		var title = _ref5.title;
		var message = _ref5.message;
		var actions = _ref5.actions;

		if (actions.length === 0) {
			return _react2['default'].createElement('noscript', null);
		}

		var _actions = _toArray(actions);

		var firstAction = _actions[0];

		var otherActions = _actions.slice(1);

		if (firstAction.preferred) {
			// Preferred action is separated
			return _react2['default'].createElement(
				_Box2['default'],
				{ column: true, reverse: true, grow: 1 },
				_react2['default'].createElement(ActionSheetBlock, { actions: [firstAction] }),
				_react2['default'].createElement(ActionSheetBlock, { title: title, message: message, actions: otherActions })
			);
		} else {
			return _react2['default'].createElement(ActionSheetBlock, { title: title, message: message, actions: actions });
		}
	}

	function AlertBody(_ref6) {
		var title = _ref6.title;
		var message = _ref6.message;
		var textFields = _ref6.textFields;
		var actions = _ref6.actions;

		var textFieldsBox = undefined;
		if (textFields && textFields.length > 0) {
			var textFieldElements = textFields.map(function (_ref7, index) {
				var title = _ref7.title;
				return _react2['default'].createElement(
					_Box2['default'],
					{ key: index,
						outline: true,
						padding: 6
					},
					_react2['default'].createElement(
						_Text2['default'],
						{ size: 13 },
						title
					)
				);
			});
			textFieldsBox = _react2['default'].createElement(_Box2['default'], { column: true, shrink: 0, margin: { top: 16 }, children: textFieldElements });
		}

		return _react2['default'].createElement(
			_Box2['default'],
			{ column: true, outline: true, grow: 1, margin: 20, overflow: 'hidden', backgroundColor: _reactSowRgba2['default'].whiteValue(255, 0.94), cornerRadius: 12 },
			_react2['default'].createElement(TextBlock, { title: title, message: message, trailingElement: textFieldsBox }),
			_react2['default'].createElement(ButtonsList, { actions: actions, allowColumn: true })
		);
	}

	function Alert(_ref8) {
		var title = _ref8.title;
		var message = _ref8.message;
		var textFields = _ref8.textFields;
		var actions = _ref8.actions;
		var _ref8$actionSheet = _ref8.actionSheet;
		var actionSheet = _ref8$actionSheet === undefined ? false : _ref8$actionSheet;

		return _react2['default'].createElement(
			_Box2['default'],
			{ row: true, grow: 1, alignItems: 'center' },
			actionSheet ? _react2['default'].createElement(ActionSheetBody, { title: title, message: message, actions: actions }) : _react2['default'].createElement(AlertBody, { title: title, message: message, textFields: textFields, actions: actions })
		);
	}

	module.exports = exports['default'];

/***/ },
/* 48 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.title = exports.Preview = exports.extendTagConds = exports.record = exports.nav = exports.columns = exports.list = exports.hidden = exports.code = exports.video = exports.placeholderImage = exports.image = exports.imageMaker = exports.text = exports.choice = exports.cta = exports.button = exports.field = exports.isPassword = undefined;

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/destinations/Vanilla.js';
	exports.init = init;
	exports.head = head;
	exports.deinit = deinit;

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactSeeds = __webpack_require__(7);

	var _reactSeeds2 = _interopRequireDefault(_reactSeeds);

	var _rgba = __webpack_require__(28);

	var _rgba2 = _interopRequireDefault(_rgba);

	var _repeat = __webpack_require__(49);

	var _repeat2 = _interopRequireDefault(_repeat);

	var _render = __webpack_require__(73);

	var _multilinedText = __webpack_require__(74);

	var _multilinedText2 = _interopRequireDefault(_multilinedText);

	var _divider = __webpack_require__(75);

	var _divider2 = _interopRequireDefault(_divider);

	var _JSONComponent = __webpack_require__(76);

	var _JSONComponent2 = _interopRequireDefault(_JSONComponent);

	var _CollectedImage = __webpack_require__(79);

	var _CollectedImage2 = _interopRequireDefault(_CollectedImage);

	var _UnsplashImage = __webpack_require__(80);

	var _UnsplashImage2 = _interopRequireDefault(_UnsplashImage);

	var _Message = __webpack_require__(81);

	var Message = _interopRequireWildcard(_Message);

	var _Swatch = __webpack_require__(82);

	var Swatch = _interopRequireWildcard(_Swatch);

	var _Distribution = __webpack_require__(83);

	var Distribution = _interopRequireWildcard(_Distribution);

	var _LayoutCalculator = __webpack_require__(84);

	var LayoutCalculator = _interopRequireWildcard(_LayoutCalculator);

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var whenPresent = _ramda2.default.unless(_ramda2.default.isNil);

	var isPassword = exports.isPassword = function isPassword(tags, texts) {
		return _ramda2.default.has('password', tags) || _ramda2.default.any(_ramda2.default.test(/\bpassword\b/i), texts);
	};

	var field = exports.field = function field(tags, mentions, texts, children, Element, resolveContent) {
		var value = null;
		var onChange = void 0;
		if (_ramda2.default.has('value', tags)) {
			value = resolveContent(tags.value);
			/*value = R.unless(
	  	R.is(String),
	  	R.always(null),
	  	resolveContent(tags.value)
	  )*/
			onChange = function onChange(event) {
				var newValue = event.target.value;
				resolveContent(tags.value, { alter: _ramda2.default.always(newValue) });
			};
		}

		return _react2.default.createElement(
			_reactSeeds.Seed,
			{ Component: 'label', column: true,
				alignSelf: 'center',
				__source: {
					fileName: _jsxFileName,
					lineNumber: 42
				},
				__self: undefined
			},
			_react2.default.createElement('span', { key: 'label', children: texts, style: { display: 'block' }, __source: {
					fileName: _jsxFileName,
					lineNumber: 45
				},
				__self: undefined
			}),
			_react2.default.createElement('input', { key: 'input',
				type: isPassword(tags, texts) ? 'password' : 'text',
				value: value,
				onChange: onChange,
				__source: {
					fileName: _jsxFileName,
					lineNumber: 46
				},
				__self: undefined
			})
		);
	};

	var button = exports.button = function button(tags, mentions, texts) {
		return _react2.default.createElement(_reactSeeds.Seed, { Component: 'button',
			shrink: 0, alignSelf: 'center',
			margin: { base: 'auto', bottom: '0.5rem' }
			//maxWidth='20em'
			, children: texts,
			__source: {
				fileName: _jsxFileName,
				lineNumber: 56
			},
			__self: undefined
		});
	};
	var cta = exports.cta = button;

	function ChoiceSelect(_ref) {
		var _this = this;

		var value = _ref.value,
		    texts = _ref.texts,
		    items = _ref.items;

		return _react2.default.createElement(
			'label',
			_extends({}, (0, _reactSeeds2.default)({ column: true }), {
				__source: {
					fileName: _jsxFileName,
					lineNumber: 67
				},
				__self: this
			}),
			_react2.default.createElement('span', { children: texts, style: { display: 'block' }, __source: {
					fileName: _jsxFileName,
					lineNumber: 68
				},
				__self: this
			}),
			_react2.default.createElement(
				_reactSeeds.Seed,
				{ Component: 'select',
					value: value,
					shrink: 0
					//maxWidth='20em'
					, font: { size: 16 },
					__source: {
						fileName: _jsxFileName,
						lineNumber: 69
					},
					__self: this
				},
				items.map(function (_ref2) {
					var texts = _ref2.texts,
					    tags = _ref2.tags;
					return _react2.default.createElement('option', { key: texts,
						value: texts[0], children: tags.texts || texts,
						__source: {
							fileName: _jsxFileName,
							lineNumber: 77
						},
						__self: _this
					});
				})
			)
		);
	}

	function ChoiceCheckbox(_ref3) {
		var value = _ref3.value,
		    texts = _ref3.texts;

		return _react2.default.createElement(
			'label',
			_extends({}, (0, _reactSeeds2.default)({ text: { align: 'center' } }), {
				__source: {
					fileName: _jsxFileName,
					lineNumber: 89
				},
				__self: this
			}),
			_react2.default.createElement('input', { type: 'checkbox', value: value, __source: {
					fileName: _jsxFileName,
					lineNumber: 90
				},
				__self: this
			}),
			_react2.default.createElement('span', { children: texts, __source: {
					fileName: _jsxFileName,
					lineNumber: 91
				},
				__self: this
			})
		);
	}

	var choice = exports.choice = function choice(tags, mentions, texts, children, Element, resolveContent) {
		var hasChildren = children.length > 0;
		if (hasChildren) {
			return _react2.default.createElement(ChoiceSelect, {
				value: tags.value,
				texts: texts,
				items: children,
				__source: {
					fileName: _jsxFileName,
					lineNumber: 99
				},
				__self: undefined
			});
		} else {
			return _react2.default.createElement(ChoiceCheckbox, {
				value: tags.value,
				texts: texts,
				__source: {
					fileName: _jsxFileName,
					lineNumber: 106
				},
				__self: undefined
			});
		}
	};

	var wrapForTags = function wrapForTags(tags, resolveContent, element) {
		if (_ramda2.default.has('link', tags)) {
			var url = resolveContent(tags.link);
			console.log('#link', url, tags.link);
			return _react2.default.createElement('a', { href: url, rel: 'nofollow', children: element, __source: {
					fileName: _jsxFileName,
					lineNumber: 118
				},
				__self: undefined
			});
		} else {
			return element;
		}
	};

	var wrapInInline = _ramda2.default.curry(function (tags, element) {
		if (_ramda2.default.has('small', tags)) {
			element = _react2.default.createElement('small', { children: element, __source: {
					fileName: _jsxFileName,
					lineNumber: 129
				},
				__self: undefined
			});
		}

		return element;
	});

	var text = exports.text = function text(tags, mentions, texts, children, Element, resolveContent) {
		var _ref4 = _ramda2.default.has('primary', tags) ? ['h1', '2em', 'center'] : _ramda2.default.has('secondary', tags) ? ['h2', '1.5em', 'center'] : _ramda2.default.has('tertiary', tags) ? ['h3', '1.25em', 'left'] : _ramda2.default.has('quote', tags) ? ['blockquote', '1em', 'left'] : ['p', '1em', 'left'],
		    Component = _ref4[0],
		    fontSize = _ref4[1],
		    textAlign = _ref4[2];

		console.log('#text', resolveContent({ mentions: mentions, texts: texts }), texts);

		return wrapForTags(tags, resolveContent, _react2.default.createElement(_reactSeeds.Seed, {
			maxWidth: '40rem',
			alignSelf: 'center',
			margin: 'auto',
			text: { align: textAlign },
			font: { size: fontSize },
			children: (0, _multilinedText2.default)(resolveContent({ mentions: mentions, texts: texts }), Component, wrapInInline(tags)),
			__source: {
				fileName: _jsxFileName,
				lineNumber: 157
			},
			__self: undefined
		}));
	};

	// Images

	var imageHeight = 150;
	var imageBackground = { color: _rgba2.default.whiteValue(0, 0.1) };

	var placeholderImageContent = function placeholderImageContent(tags, texts, resolveContent) {
		return _react2.default.createElement(_reactSeeds.Seed, { column: true, justifyContent: 'center',
			minHeight: imageHeight,
			font: { style: 'italic' },
			background: imageBackground,
			children: texts,
			__source: {
				fileName: _jsxFileName,
				lineNumber: 181
			},
			__self: undefined
		});
	};

	var richImageContent = function richImageContent(tags, texts, resolveContent) {
		if (_ramda2.default.has('unsplash', tags)) {
			var category = resolveContent(tags['unsplash']);
			category = category.length > 0 ? category[0] : null;
			return _react2.default.createElement(_UnsplashImage2.default, {
				category: category,
				texts: texts,
				__source: {
					fileName: _jsxFileName,
					lineNumber: 194
				},
				__self: undefined
			});
		} else if (_ramda2.default.has('collected', tags)) {
			return _react2.default.createElement(_CollectedImage2.default, {
				sha256: resolveContent(tags['collected']),
				width: whenPresent(resolveContent, tags['width']),
				height: whenPresent(resolveContent, tags['height']),
				texts: texts,
				__source: {
					fileName: _jsxFileName,
					lineNumber: 202
				},
				__self: undefined
			});
		} else {
			return placeholderImageContent(tags, texts, resolveContent);
		}
	};

	var imageMaker = exports.imageMaker = function imageMaker(imageContent) {
		return function (tags, mentions, texts, children, Element, resolveContent) {
			return _react2.default.createElement(_reactSeeds.Seed, { Component: 'figure', column: true,
				grow: 1, width: '100%',
				margin: 0,
				text: { align: 'center' },
				children: wrapForTags(tags, resolveContent, _ramda2.default.has('nocaption', tags) ? imageContent(tags, texts, resolveContent) : [imageContent(tags, null, resolveContent), _react2.default.createElement(_reactSeeds.Seed, { key: 'caption', Component: 'figcaption',
					text: { lineHeight: '1.3' },
					font: { style: 'italic' },
					children: texts,
					__source: {
						fileName: _jsxFileName,
						lineNumber: 227
					},
					__self: undefined
				})]),
				__source: {
					fileName: _jsxFileName,
					lineNumber: 217
				},
				__self: undefined
			});
		};
	};

	var image = exports.image = imageMaker(richImageContent);
	var placeholderImage = exports.placeholderImage = imageMaker(placeholderImageContent);

	var video = exports.video = function video(tags, mentions, texts) {
		return _react2.default.createElement(_reactSeeds.Seed, { Component: 'figure', column: true,
			grow: 1, alignItems: 'center', justifyContent: 'center',
			width: '100%', height: 0,
			padding: { top: 9 / 16 / 2 * 100 + '%', bottom: 9 / 16 / 2 * 100 + '%' },
			background: { color: _rgba2.default.whiteValue(0, 0.1) },
			children: '\u25B6',
			__source: {
				fileName: _jsxFileName,
				lineNumber: 243
			},
			__self: undefined
		});
	};

	var code = exports.code = function code(tags, mentions, texts, children, Element, resolveContent) {
		return _react2.default.createElement(
			_reactSeeds.Seed,
			{ Component: 'pre',
				maxWidth: '100%',
				overflow: 'scroll',
				__source: {
					fileName: _jsxFileName,
					lineNumber: 253
				},
				__self: undefined
			},
			_react2.default.createElement(_reactSeeds.Seed, { Component: 'code',
				children: resolveContent({ mentions: mentions, texts: texts }),
				__source: {
					fileName: _jsxFileName,
					lineNumber: 257
				},
				__self: undefined
			})
		);
	};

	var isHiddenForTags = _ramda2.default.propSatisfies(Boolean, 'hidden');

	var hidden = exports.hidden = function hidden(tags, mentions, texts) {
		return _react2.default.createElement('noscript', {
			__source: {
				fileName: _jsxFileName,
				lineNumber: 266
			},
			__self: undefined
		});
	};

	var list = exports.list = function list(tags, mentions, texts, children, Element, resolveContent) {
		var Component = _ramda2.default.propEq('ordered', true, tags) ? 'ol' : 'ul';
		return _react2.default.createElement(
			_reactSeeds.Seed,
			{
				__source: {
					fileName: _jsxFileName,
					lineNumber: 272
				},
				__self: undefined
			},
			text(tags, mentions, texts || [], children, Element, resolveContent),
			_react2.default.createElement(
				_reactSeeds.Seed,
				{ Component: Component,

					__source: {
						fileName: _jsxFileName,
						lineNumber: 274
					},
					__self: undefined
				},
				children.map(function (element, index) {
					return _react2.default.createElement(
						'li',
						{ key: index, __source: {
								fileName: _jsxFileName,
								lineNumber: 279
							},
							__self: undefined
						},
						_react2.default.createElement(Element, _extends({}, element, {
							__source: {
								fileName: _jsxFileName,
								lineNumber: 280
							},
							__self: undefined
						}))
					);
				})
			)
		);
	};

	var columnsComponentForTags = _ramda2.default.cond([[_ramda2.default.has('nav'), _ramda2.default.always('nav')], [_ramda2.default.has('figure'), _ramda2.default.always('figure')], [_ramda2.default.T, _ramda2.default.always('div')]]);

	var columns = exports.columns = function columns(tags, mentions, texts, children, Element, resolveContent) {
		var columnWidth = _ramda2.default.ifElse(_ramda2.default.gt(_ramda2.default.__, 0), // Greater than 0
		function (number) {
			return 100.0 / number + '%';
		}, _ramda2.default.always(null))(parseInt(resolveContent(tags.columns), 10));

		var renderColumn = function renderColumn(props) {
			return _react2.default.createElement(
				'div',
				{ style: { flexBasis: columnWidth }, __source: {
						fileName: _jsxFileName,
						lineNumber: 303
					},
					__self: undefined
				},
				Element(props)
			);
		};

		return _react2.default.createElement(
			_reactSeeds.Seed,
			{ Component: columnsComponentForTags(tags),
				row: true, wrap: true, reverse: _ramda2.default.has('reverse', tags), justifyContent: 'center',
				width: '100%',
				__source: {
					fileName: _jsxFileName,
					lineNumber: 309
				},
				__self: undefined
			},
			// Render content, interleaving an optional divider
			_ramda2.default.pipe(_ramda2.default.converge(_ramda2.default.concat, [_ramda2.default.pipe(_ramda2.default.init, _ramda2.default.map(renderColumn)), _ramda2.default.pipe(_ramda2.default.last, _ramda2.default.ifElse(_ramda2.default.isNil, _ramda2.default.always([]), renderColumn))]))(children)
		);
	};

	var nav = exports.nav = columns;

	var record = exports.record = function record(tags, mentions, texts, children, Element, resolveContent) {
		if (mentions.length > 0) {
			return _react2.default.createElement(_JSONComponent2.default, { isDeserialized: true, json: mentions[0], __source: {
					fileName: _jsxFileName,
					lineNumber: 351
				},
				__self: undefined
			});
		} else {
			return _react2.default.createElement(_JSONComponent2.default, { isDeserialized: true, json: texts, __source: {
					fileName: _jsxFileName,
					lineNumber: 356
				},
				__self: undefined
			});
		}
	};

	// import Frame from 'react-frame-component'

	// export const gist = (tags, mentions, texts, children, Element, resolveContent) => (
	// 	<Frame head={ <script src={ resolveContent({ mentions, texts }) + '.js' } /> } />
	// )

	var extendTagConds = exports.extendTagConds = function extendTagConds(conds) {
		return _ramda2.default.pipe(Message.useWithFallback, Swatch.useWithFallback, Distribution.useWithFallback, LayoutCalculator.useWithFallback)(_ramda2.default.cond([[isHiddenForTags, _ramda2.default.curry(hidden)]].concat(conds, [[_ramda2.default.has('field'), _ramda2.default.curry(field)], [_ramda2.default.has('button'), _ramda2.default.curry(button)], [_ramda2.default.has('cta'), _ramda2.default.curry(cta)], [_ramda2.default.has('choice'), _ramda2.default.curry(choice)], [_ramda2.default.has('image'), _ramda2.default.curry(image)], [_ramda2.default.has('video'), _ramda2.default.curry(video)], [_ramda2.default.has('code'), _ramda2.default.curry(code)], [_ramda2.default.has('columns'), _ramda2.default.curry(columns)], [_ramda2.default.has('nav'), _ramda2.default.curry(nav)], [_ramda2.default.has('record'), _ramda2.default.curry(record)],
		//[ R.has('gist'), R.curry(gist) ],
		[_ramda2.default.T, _ramda2.default.curry(list)]])));
	};

	var elementRendererForTags = extendTagConds([]);

	var Preview = exports.Preview = (0, _render.renderTreeUsing)({
		elementRendererForTags: elementRendererForTags
	});

	function init() {}

	var title = exports.title = 'Vanilla Web';

	function head() {
		return [_react2.default.createElement('style', { children: '\nhtml {\n\theight: 100%;\n\tbackground-color: #fdfdfd;\n}\nhtml, h1, input, button {\n\tfont-family: \'Lato\', sans-serif;\n}\nbody {\n\theight: 100%;\n\tmargin: 0;\n}\n', __source: {
				fileName: _jsxFileName,
				lineNumber: 402
			},
			__self: this
		})];
	}

	function deinit() {}

/***/ },
/* 49 */
/***/ function(module, exports, __webpack_require__) {

	var baseRepeat = __webpack_require__(50),
	    isIterateeCall = __webpack_require__(51),
	    toInteger = __webpack_require__(64),
	    toString = __webpack_require__(69);

	/**
	 * Repeats the given string `n` times.
	 *
	 * @static
	 * @memberOf _
	 * @since 3.0.0
	 * @category String
	 * @param {string} [string=''] The string to repeat.
	 * @param {number} [n=1] The number of times to repeat the string.
	 * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
	 * @returns {string} Returns the repeated string.
	 * @example
	 *
	 * _.repeat('*', 3);
	 * // => '***'
	 *
	 * _.repeat('abc', 2);
	 * // => 'abcabc'
	 *
	 * _.repeat('abc', 0);
	 * // => ''
	 */
	function repeat(string, n, guard) {
	  if ((guard ? isIterateeCall(string, n, guard) : n === undefined)) {
	    n = 1;
	  } else {
	    n = toInteger(n);
	  }
	  return baseRepeat(toString(string), n);
	}

	module.exports = repeat;


/***/ },
/* 50 */
/***/ function(module, exports) {

	/** Used as references for various `Number` constants. */
	var MAX_SAFE_INTEGER = 9007199254740991;

	/* Built-in method references for those with the same name as other `lodash` methods. */
	var nativeFloor = Math.floor;

	/**
	 * The base implementation of `_.repeat` which doesn't coerce arguments.
	 *
	 * @private
	 * @param {string} string The string to repeat.
	 * @param {number} n The number of times to repeat the string.
	 * @returns {string} Returns the repeated string.
	 */
	function baseRepeat(string, n) {
	  var result = '';
	  if (!string || n < 1 || n > MAX_SAFE_INTEGER) {
	    return result;
	  }
	  // Leverage the exponentiation by squaring algorithm for a faster repeat.
	  // See https://en.wikipedia.org/wiki/Exponentiation_by_squaring for more details.
	  do {
	    if (n % 2) {
	      result += string;
	    }
	    n = nativeFloor(n / 2);
	    if (n) {
	      string += string;
	    }
	  } while (n);

	  return result;
	}

	module.exports = baseRepeat;


/***/ },
/* 51 */
/***/ function(module, exports, __webpack_require__) {

	var eq = __webpack_require__(52),
	    isArrayLike = __webpack_require__(53),
	    isIndex = __webpack_require__(63),
	    isObject = __webpack_require__(61);

	/**
	 * Checks if the given arguments are from an iteratee call.
	 *
	 * @private
	 * @param {*} value The potential iteratee value argument.
	 * @param {*} index The potential iteratee index or key argument.
	 * @param {*} object The potential iteratee object argument.
	 * @returns {boolean} Returns `true` if the arguments are from an iteratee call,
	 *  else `false`.
	 */
	function isIterateeCall(value, index, object) {
	  if (!isObject(object)) {
	    return false;
	  }
	  var type = typeof index;
	  if (type == 'number'
	        ? (isArrayLike(object) && isIndex(index, object.length))
	        : (type == 'string' && index in object)
	      ) {
	    return eq(object[index], value);
	  }
	  return false;
	}

	module.exports = isIterateeCall;


/***/ },
/* 52 */
/***/ function(module, exports) {

	/**
	 * Performs a
	 * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
	 * comparison between two values to determine if they are equivalent.
	 *
	 * @static
	 * @memberOf _
	 * @since 4.0.0
	 * @category Lang
	 * @param {*} value The value to compare.
	 * @param {*} other The other value to compare.
	 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
	 * @example
	 *
	 * var object = { 'a': 1 };
	 * var other = { 'a': 1 };
	 *
	 * _.eq(object, object);
	 * // => true
	 *
	 * _.eq(object, other);
	 * // => false
	 *
	 * _.eq('a', 'a');
	 * // => true
	 *
	 * _.eq('a', Object('a'));
	 * // => false
	 *
	 * _.eq(NaN, NaN);
	 * // => true
	 */
	function eq(value, other) {
	  return value === other || (value !== value && other !== other);
	}

	module.exports = eq;


/***/ },
/* 53 */
/***/ function(module, exports, __webpack_require__) {

	var isFunction = __webpack_require__(54),
	    isLength = __webpack_require__(62);

	/**
	 * Checks if `value` is array-like. A value is considered array-like if it's
	 * not a function and has a `value.length` that's an integer greater than or
	 * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
	 *
	 * @static
	 * @memberOf _
	 * @since 4.0.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
	 * @example
	 *
	 * _.isArrayLike([1, 2, 3]);
	 * // => true
	 *
	 * _.isArrayLike(document.body.children);
	 * // => true
	 *
	 * _.isArrayLike('abc');
	 * // => true
	 *
	 * _.isArrayLike(_.noop);
	 * // => false
	 */
	function isArrayLike(value) {
	  return value != null && isLength(value.length) && !isFunction(value);
	}

	module.exports = isArrayLike;


/***/ },
/* 54 */
/***/ function(module, exports, __webpack_require__) {

	var baseGetTag = __webpack_require__(55),
	    isObject = __webpack_require__(61);

	/** `Object#toString` result references. */
	var asyncTag = '[object AsyncFunction]',
	    funcTag = '[object Function]',
	    genTag = '[object GeneratorFunction]',
	    proxyTag = '[object Proxy]';

	/**
	 * Checks if `value` is classified as a `Function` object.
	 *
	 * @static
	 * @memberOf _
	 * @since 0.1.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is a function, else `false`.
	 * @example
	 *
	 * _.isFunction(_);
	 * // => true
	 *
	 * _.isFunction(/abc/);
	 * // => false
	 */
	function isFunction(value) {
	  if (!isObject(value)) {
	    return false;
	  }
	  // The use of `Object#toString` avoids issues with the `typeof` operator
	  // in Safari 9 which returns 'object' for typed arrays and other constructors.
	  var tag = baseGetTag(value);
	  return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
	}

	module.exports = isFunction;


/***/ },
/* 55 */
/***/ function(module, exports, __webpack_require__) {

	var Symbol = __webpack_require__(56),
	    getRawTag = __webpack_require__(59),
	    objectToString = __webpack_require__(60);

	/** `Object#toString` result references. */
	var nullTag = '[object Null]',
	    undefinedTag = '[object Undefined]';

	/** Built-in value references. */
	var symToStringTag = Symbol ? Symbol.toStringTag : undefined;

	/**
	 * The base implementation of `getTag` without fallbacks for buggy environments.
	 *
	 * @private
	 * @param {*} value The value to query.
	 * @returns {string} Returns the `toStringTag`.
	 */
	function baseGetTag(value) {
	  if (value == null) {
	    return value === undefined ? undefinedTag : nullTag;
	  }
	  return (symToStringTag && symToStringTag in Object(value))
	    ? getRawTag(value)
	    : objectToString(value);
	}

	module.exports = baseGetTag;


/***/ },
/* 56 */
/***/ function(module, exports, __webpack_require__) {

	var root = __webpack_require__(57);

	/** Built-in value references. */
	var Symbol = root.Symbol;

	module.exports = Symbol;


/***/ },
/* 57 */
/***/ function(module, exports, __webpack_require__) {

	var freeGlobal = __webpack_require__(58);

	/** Detect free variable `self`. */
	var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

	/** Used as a reference to the global object. */
	var root = freeGlobal || freeSelf || Function('return this')();

	module.exports = root;


/***/ },
/* 58 */
/***/ function(module, exports) {

	/* WEBPACK VAR INJECTION */(function(global) {/** Detect free variable `global` from Node.js. */
	var freeGlobal = typeof global == 'object' && global && global.Object === Object && global;

	module.exports = freeGlobal;

	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 59 */
/***/ function(module, exports, __webpack_require__) {

	var Symbol = __webpack_require__(56);

	/** Used for built-in method references. */
	var objectProto = Object.prototype;

	/** Used to check objects for own properties. */
	var hasOwnProperty = objectProto.hasOwnProperty;

	/**
	 * Used to resolve the
	 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
	 * of values.
	 */
	var nativeObjectToString = objectProto.toString;

	/** Built-in value references. */
	var symToStringTag = Symbol ? Symbol.toStringTag : undefined;

	/**
	 * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
	 *
	 * @private
	 * @param {*} value The value to query.
	 * @returns {string} Returns the raw `toStringTag`.
	 */
	function getRawTag(value) {
	  var isOwn = hasOwnProperty.call(value, symToStringTag),
	      tag = value[symToStringTag];

	  try {
	    value[symToStringTag] = undefined;
	    var unmasked = true;
	  } catch (e) {}

	  var result = nativeObjectToString.call(value);
	  if (unmasked) {
	    if (isOwn) {
	      value[symToStringTag] = tag;
	    } else {
	      delete value[symToStringTag];
	    }
	  }
	  return result;
	}

	module.exports = getRawTag;


/***/ },
/* 60 */
/***/ function(module, exports) {

	/** Used for built-in method references. */
	var objectProto = Object.prototype;

	/**
	 * Used to resolve the
	 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
	 * of values.
	 */
	var nativeObjectToString = objectProto.toString;

	/**
	 * Converts `value` to a string using `Object.prototype.toString`.
	 *
	 * @private
	 * @param {*} value The value to convert.
	 * @returns {string} Returns the converted string.
	 */
	function objectToString(value) {
	  return nativeObjectToString.call(value);
	}

	module.exports = objectToString;


/***/ },
/* 61 */
/***/ function(module, exports) {

	/**
	 * Checks if `value` is the
	 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
	 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
	 *
	 * @static
	 * @memberOf _
	 * @since 0.1.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
	 * @example
	 *
	 * _.isObject({});
	 * // => true
	 *
	 * _.isObject([1, 2, 3]);
	 * // => true
	 *
	 * _.isObject(_.noop);
	 * // => true
	 *
	 * _.isObject(null);
	 * // => false
	 */
	function isObject(value) {
	  var type = typeof value;
	  return value != null && (type == 'object' || type == 'function');
	}

	module.exports = isObject;


/***/ },
/* 62 */
/***/ function(module, exports) {

	/** Used as references for various `Number` constants. */
	var MAX_SAFE_INTEGER = 9007199254740991;

	/**
	 * Checks if `value` is a valid array-like length.
	 *
	 * **Note:** This method is loosely based on
	 * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
	 *
	 * @static
	 * @memberOf _
	 * @since 4.0.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
	 * @example
	 *
	 * _.isLength(3);
	 * // => true
	 *
	 * _.isLength(Number.MIN_VALUE);
	 * // => false
	 *
	 * _.isLength(Infinity);
	 * // => false
	 *
	 * _.isLength('3');
	 * // => false
	 */
	function isLength(value) {
	  return typeof value == 'number' &&
	    value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
	}

	module.exports = isLength;


/***/ },
/* 63 */
/***/ function(module, exports) {

	/** Used as references for various `Number` constants. */
	var MAX_SAFE_INTEGER = 9007199254740991;

	/** Used to detect unsigned integer values. */
	var reIsUint = /^(?:0|[1-9]\d*)$/;

	/**
	 * Checks if `value` is a valid array-like index.
	 *
	 * @private
	 * @param {*} value The value to check.
	 * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
	 * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
	 */
	function isIndex(value, length) {
	  length = length == null ? MAX_SAFE_INTEGER : length;
	  return !!length &&
	    (typeof value == 'number' || reIsUint.test(value)) &&
	    (value > -1 && value % 1 == 0 && value < length);
	}

	module.exports = isIndex;


/***/ },
/* 64 */
/***/ function(module, exports, __webpack_require__) {

	var toFinite = __webpack_require__(65);

	/**
	 * Converts `value` to an integer.
	 *
	 * **Note:** This method is loosely based on
	 * [`ToInteger`](http://www.ecma-international.org/ecma-262/7.0/#sec-tointeger).
	 *
	 * @static
	 * @memberOf _
	 * @since 4.0.0
	 * @category Lang
	 * @param {*} value The value to convert.
	 * @returns {number} Returns the converted integer.
	 * @example
	 *
	 * _.toInteger(3.2);
	 * // => 3
	 *
	 * _.toInteger(Number.MIN_VALUE);
	 * // => 0
	 *
	 * _.toInteger(Infinity);
	 * // => 1.7976931348623157e+308
	 *
	 * _.toInteger('3.2');
	 * // => 3
	 */
	function toInteger(value) {
	  var result = toFinite(value),
	      remainder = result % 1;

	  return result === result ? (remainder ? result - remainder : result) : 0;
	}

	module.exports = toInteger;


/***/ },
/* 65 */
/***/ function(module, exports, __webpack_require__) {

	var toNumber = __webpack_require__(66);

	/** Used as references for various `Number` constants. */
	var INFINITY = 1 / 0,
	    MAX_INTEGER = 1.7976931348623157e+308;

	/**
	 * Converts `value` to a finite number.
	 *
	 * @static
	 * @memberOf _
	 * @since 4.12.0
	 * @category Lang
	 * @param {*} value The value to convert.
	 * @returns {number} Returns the converted number.
	 * @example
	 *
	 * _.toFinite(3.2);
	 * // => 3.2
	 *
	 * _.toFinite(Number.MIN_VALUE);
	 * // => 5e-324
	 *
	 * _.toFinite(Infinity);
	 * // => 1.7976931348623157e+308
	 *
	 * _.toFinite('3.2');
	 * // => 3.2
	 */
	function toFinite(value) {
	  if (!value) {
	    return value === 0 ? value : 0;
	  }
	  value = toNumber(value);
	  if (value === INFINITY || value === -INFINITY) {
	    var sign = (value < 0 ? -1 : 1);
	    return sign * MAX_INTEGER;
	  }
	  return value === value ? value : 0;
	}

	module.exports = toFinite;


/***/ },
/* 66 */
/***/ function(module, exports, __webpack_require__) {

	var isObject = __webpack_require__(61),
	    isSymbol = __webpack_require__(67);

	/** Used as references for various `Number` constants. */
	var NAN = 0 / 0;

	/** Used to match leading and trailing whitespace. */
	var reTrim = /^\s+|\s+$/g;

	/** Used to detect bad signed hexadecimal string values. */
	var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;

	/** Used to detect binary string values. */
	var reIsBinary = /^0b[01]+$/i;

	/** Used to detect octal string values. */
	var reIsOctal = /^0o[0-7]+$/i;

	/** Built-in method references without a dependency on `root`. */
	var freeParseInt = parseInt;

	/**
	 * Converts `value` to a number.
	 *
	 * @static
	 * @memberOf _
	 * @since 4.0.0
	 * @category Lang
	 * @param {*} value The value to process.
	 * @returns {number} Returns the number.
	 * @example
	 *
	 * _.toNumber(3.2);
	 * // => 3.2
	 *
	 * _.toNumber(Number.MIN_VALUE);
	 * // => 5e-324
	 *
	 * _.toNumber(Infinity);
	 * // => Infinity
	 *
	 * _.toNumber('3.2');
	 * // => 3.2
	 */
	function toNumber(value) {
	  if (typeof value == 'number') {
	    return value;
	  }
	  if (isSymbol(value)) {
	    return NAN;
	  }
	  if (isObject(value)) {
	    var other = typeof value.valueOf == 'function' ? value.valueOf() : value;
	    value = isObject(other) ? (other + '') : other;
	  }
	  if (typeof value != 'string') {
	    return value === 0 ? value : +value;
	  }
	  value = value.replace(reTrim, '');
	  var isBinary = reIsBinary.test(value);
	  return (isBinary || reIsOctal.test(value))
	    ? freeParseInt(value.slice(2), isBinary ? 2 : 8)
	    : (reIsBadHex.test(value) ? NAN : +value);
	}

	module.exports = toNumber;


/***/ },
/* 67 */
/***/ function(module, exports, __webpack_require__) {

	var baseGetTag = __webpack_require__(55),
	    isObjectLike = __webpack_require__(68);

	/** `Object#toString` result references. */
	var symbolTag = '[object Symbol]';

	/**
	 * Checks if `value` is classified as a `Symbol` primitive or object.
	 *
	 * @static
	 * @memberOf _
	 * @since 4.0.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
	 * @example
	 *
	 * _.isSymbol(Symbol.iterator);
	 * // => true
	 *
	 * _.isSymbol('abc');
	 * // => false
	 */
	function isSymbol(value) {
	  return typeof value == 'symbol' ||
	    (isObjectLike(value) && baseGetTag(value) == symbolTag);
	}

	module.exports = isSymbol;


/***/ },
/* 68 */
/***/ function(module, exports) {

	/**
	 * Checks if `value` is object-like. A value is object-like if it's not `null`
	 * and has a `typeof` result of "object".
	 *
	 * @static
	 * @memberOf _
	 * @since 4.0.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
	 * @example
	 *
	 * _.isObjectLike({});
	 * // => true
	 *
	 * _.isObjectLike([1, 2, 3]);
	 * // => true
	 *
	 * _.isObjectLike(_.noop);
	 * // => false
	 *
	 * _.isObjectLike(null);
	 * // => false
	 */
	function isObjectLike(value) {
	  return value != null && typeof value == 'object';
	}

	module.exports = isObjectLike;


/***/ },
/* 69 */
/***/ function(module, exports, __webpack_require__) {

	var baseToString = __webpack_require__(70);

	/**
	 * Converts `value` to a string. An empty string is returned for `null`
	 * and `undefined` values. The sign of `-0` is preserved.
	 *
	 * @static
	 * @memberOf _
	 * @since 4.0.0
	 * @category Lang
	 * @param {*} value The value to convert.
	 * @returns {string} Returns the converted string.
	 * @example
	 *
	 * _.toString(null);
	 * // => ''
	 *
	 * _.toString(-0);
	 * // => '-0'
	 *
	 * _.toString([1, 2, 3]);
	 * // => '1,2,3'
	 */
	function toString(value) {
	  return value == null ? '' : baseToString(value);
	}

	module.exports = toString;


/***/ },
/* 70 */
/***/ function(module, exports, __webpack_require__) {

	var Symbol = __webpack_require__(56),
	    arrayMap = __webpack_require__(71),
	    isArray = __webpack_require__(72),
	    isSymbol = __webpack_require__(67);

	/** Used as references for various `Number` constants. */
	var INFINITY = 1 / 0;

	/** Used to convert symbols to primitives and strings. */
	var symbolProto = Symbol ? Symbol.prototype : undefined,
	    symbolToString = symbolProto ? symbolProto.toString : undefined;

	/**
	 * The base implementation of `_.toString` which doesn't convert nullish
	 * values to empty strings.
	 *
	 * @private
	 * @param {*} value The value to process.
	 * @returns {string} Returns the string.
	 */
	function baseToString(value) {
	  // Exit early for strings to avoid a performance hit in some environments.
	  if (typeof value == 'string') {
	    return value;
	  }
	  if (isArray(value)) {
	    // Recursively convert values (susceptible to call stack limits).
	    return arrayMap(value, baseToString) + '';
	  }
	  if (isSymbol(value)) {
	    return symbolToString ? symbolToString.call(value) : '';
	  }
	  var result = (value + '');
	  return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
	}

	module.exports = baseToString;


/***/ },
/* 71 */
/***/ function(module, exports) {

	/**
	 * A specialized version of `_.map` for arrays without support for iteratee
	 * shorthands.
	 *
	 * @private
	 * @param {Array} [array] The array to iterate over.
	 * @param {Function} iteratee The function invoked per iteration.
	 * @returns {Array} Returns the new mapped array.
	 */
	function arrayMap(array, iteratee) {
	  var index = -1,
	      length = array == null ? 0 : array.length,
	      result = Array(length);

	  while (++index < length) {
	    result[index] = iteratee(array[index], index, array);
	  }
	  return result;
	}

	module.exports = arrayMap;


/***/ },
/* 72 */
/***/ function(module, exports) {

	/**
	 * Checks if `value` is classified as an `Array` object.
	 *
	 * @static
	 * @memberOf _
	 * @since 0.1.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is an array, else `false`.
	 * @example
	 *
	 * _.isArray([1, 2, 3]);
	 * // => true
	 *
	 * _.isArray(document.body.children);
	 * // => false
	 *
	 * _.isArray('abc');
	 * // => false
	 *
	 * _.isArray(_.noop);
	 * // => false
	 */
	var isArray = Array.isArray;

	module.exports = isArray;


/***/ },
/* 73 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.renderTreeUsing = exports.DefaultMaster = exports.DefaultSection = exports.renderElement = undefined;

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/destinations/render.js';

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactSeeds = __webpack_require__(7);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var resolveContentIn = _ramda2.default.curry(function resolveItemIn(source, path) {
		//path = R.filter(R.isNil)
		console.log('resolveContentIn', path, source);
		path = _ramda2.default.insertAll(1, ['content'], path);
		return _ramda2.default.path(path, source);
	});

	var variationForItemIn = _ramda2.default.curry(function adjustItemIn(source, path) {
		var id = _ramda2.default.head(path);
		return _ramda2.default.path([id, 'variationReference'], source);
	});

	var resolveContentUsing = function resolveContentUsing(ingredients) {
		var resolveIngredientReference = resolveContentIn(ingredients);
		var variationForPath = variationForItemIn(ingredients);
		return function (value) {
			var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
			    _ref$single = _ref.single,
			    single = _ref$single === undefined ? true : _ref$single,
			    set = _ref.set,
			    alter = _ref.alter;

			if (_ramda2.default.isNil(value)) {
				return;
			} else if (value.mentions != null && value.mentions.length > 0 && value.mentions[0] != null) {
				console.log('MENTIONS', { set: set, alter: alter });
				if (set) {
					_ramda2.default.forEach(function (item) {
						return item.set(set);
					}, result);
				} else if (alter) {
					var path = value.mentions[0];
					var variation = variationForPath(path);
					console.log('altering variation', variation);
					var innerPath = _ramda2.default.tail(path);
					variation.adjustPath(innerPath, alter);
				} else {
					console.log('RESOLVE', value.mentions);
					var resolved = _ramda2.default.map(resolveIngredientReference, value.mentions);
					console.log('RESOLVED', resolved);
					if (resolved == null) {
						return;
					}
					return single ? resolved[0] : resolved;
				}
			} else if (value.texts != null) {
				return value.texts;
			} else {
				return value;
			}
		};
	};

	function elementFromText(text) {
		return {
			text: text,
			references: [],
			tags: {},
			children: []
		};
	}

	var renderElement = exports.renderElement = function renderElement(_ref2) {
		var ingredients = _ref2.ingredients,
		    elementRendererForTags = _ref2.elementRendererForTags;

		var resolveContent = resolveContentUsing(ingredients);

		var extra = {
			elementFromText: elementFromText
		};

		var Element = _ramda2.default.converge(_ramda2.default.call, [_ramda2.default.pipe(_ramda2.default.props(['defaultTags', 'tags']), _ramda2.default.apply(_ramda2.default.mergeWith(_ramda2.default.merge)), elementRendererForTags), _ramda2.default.prop('mentions'), _ramda2.default.prop('texts'), _ramda2.default.prop('children'), function (ignore) {
			return Element;
		}, // Have to put in closure as it is currently being assigned
		_ramda2.default.always(resolveContent), _ramda2.default.always(extra)]);

		Element.renderArray = function (options, array) {
			return array.map(function (element, index) {
				return _react2.default.createElement(Element, _extends({ key: index
				}, options, element, {
					__source: {
						fileName: _jsxFileName,
						lineNumber: 92
					},
					__self: undefined
				}));
			});
		};

		return Element;
	};

	var DefaultSection = exports.DefaultSection = function DefaultSection(_ref3) {
		var children = _ref3.children;
		return _react2.default.createElement(_reactSeeds.Seed, { Component: 'section'
			//column
			, margin: { base: '2rem', top: 0 },
			children: children,
			__source: {
				fileName: _jsxFileName,
				lineNumber: 103
			},
			__self: undefined
		});
	};

	var DefaultMaster = exports.DefaultMaster = function DefaultMaster(_ref4) {
		var children = _ref4.children;
		return _react2.default.createElement(_reactSeeds.Seed, {
			padding: { top: '1rem' },
			children: children,
			__source: {
				fileName: _jsxFileName,
				lineNumber: 111
			},
			__self: undefined
		});
	};

	var renderTreeUsing = exports.renderTreeUsing = function renderTreeUsing(_ref5) {
		var elementRendererForTags = _ref5.elementRendererForTags,
		    _ref5$Section = _ref5.Section,
		    Section = _ref5$Section === undefined ? DefaultSection : _ref5$Section,
		    _ref5$Master = _ref5.Master,
		    Master = _ref5$Master === undefined ? DefaultMaster : _ref5$Master;
		return function (_ref6) {
			var ingredients = _ref6.ingredients,
			    contentTree = _ref6.contentTree;

			// FIXME: use valueForIngredient instead that encapsulates ingredientVariationIndexes 
			var Element = renderElement({ ingredients: ingredients, elementRendererForTags: elementRendererForTags });

			return _react2.default.createElement(
				Master,
				{ ingredients: ingredients, __source: {
						fileName: _jsxFileName,
						lineNumber: 129
					},
					__self: undefined
				},
				contentTree.map(function (section, sectionIndex) {
					return _react2.default.createElement(
						Section,
						{ key: sectionIndex, __source: {
								fileName: _jsxFileName,
								lineNumber: 132
							},
							__self: undefined
						},
						section.map(function (element, elementIndex) {
							return _react2.default.createElement(Element, _extends({ key: elementIndex }, element, {
								__source: {
									fileName: _jsxFileName,
									lineNumber: 135
								},
								__self: undefined
							}));
						})
					);
				})
			);
		};
	};

/***/ },
/* 74 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/destinations/multilinedText.js';
	exports.default = multilinedText;

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var rejectEmptyStrings = _ramda2.default.filter(_ramda2.default.test(/\S/));

	function multilinedText(content) {
		var _this = this;

		var Component = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'p';
		var wrapText = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _ramda2.default.identity;

		return _ramda2.default.pipe(_ramda2.default.concat([]), _ramda2.default.map(_ramda2.default.pipe(_ramda2.default.defaultTo(''), _ramda2.default.split('\n\n'), rejectEmptyStrings, _ramda2.default.map(function (text) {
			return _react2.default.createElement(Component, { children: wrapText(text), __source: {
					fileName: _jsxFileName,
					lineNumber: 14
				},
				__self: _this
			});
		}))))(content);
	}

/***/ },
/* 75 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/destinations/divider.js';

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactSeeds = __webpack_require__(7);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var wrap = function wrap(propName, otherProps) {
		return function (value) {
			var _ref;

			return _react2.default.createElement(_reactSeeds.Seed, _extends({}, otherProps, (_ref = {}, _ref[propName] = value, _ref), {
				__source: {
					fileName: _jsxFileName,
					lineNumber: 6
				},
				__self: undefined
			}));
		};
	};

	exports.default = _ramda2.default.cond([[_ramda2.default.complement(_ramda2.default.pipe(Number, isNaN)), // Is valid number
	_ramda2.default.pipe(Number, wrap('basis', { shrink: 0 }))], [_ramda2.default.is(String), wrap('children')], [_ramda2.default.T, _ramda2.default.identity]]);

/***/ },
/* 76 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	var _isObject = __webpack_require__(61);

	var _isObject2 = _interopRequireDefault(_isObject);

	var _isNumber = __webpack_require__(77);

	var _isNumber2 = _interopRequireDefault(_isNumber);

	var _isBoolean = __webpack_require__(78);

	var _isBoolean2 = _interopRequireDefault(_isBoolean);

	var _react = __webpack_require__(2);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var li = _ramda2.default.partial(_react.createElement, ['li', null]);
	var dl = _ramda2.default.partial(_react.createElement, ['dl', null]);
	var dtAttrs = _ramda2.default.partial(_react.createElement, ['dt']);
	var ddAttrs = _ramda2.default.partial(_react.createElement, ['dd']);
	var ol = _ramda2.default.partial(_react.createElement, ['ol', null]);
	var code = _ramda2.default.partial(_react.createElement, ['code', null]);
	var em = _ramda2.default.partial(_react.createElement, ['em', null]);
	var p = _ramda2.default.partial(_react.createElement, ['p', null]);

	var renderObjectItem = function renderObjectItem(key, value) {
		return [dtAttrs({ key: 'key-' + key }, key), ddAttrs({ key: 'value-' + key }, renderJSON(value))];
	};

	var renderArrayItem = function renderArrayItem(value) {
		return li(renderJSON(value));
	};

	var renderObject = _ramda2.default.pipe(_ramda2.default.toPairs,
	//R.sortBy(R.prop(0)),
	_ramda2.default.map(_ramda2.default.apply(renderObjectItem)), _ramda2.default.tap(function (items) {
		return console.log('rendered', items);
	}), _ramda2.default.flatten, dl);

	var renderArray = _ramda2.default.pipe(_ramda2.default.map(renderArrayItem), ol);

	var renderNumber = _ramda2.default.pipe(code, p);

	var renderBoolean = _ramda2.default.pipe(function (boolean) {
		return boolean ? 'yes' : 'no';
	}, em, p);

	var renderString = p;

	var renderJSON = _ramda2.default.cond([[Array.isArray, renderArray], [_isObject2.default, renderObject], [_isNumber2.default, renderNumber], [_isBoolean2.default, renderBoolean], [_ramda2.default.T, renderString]]);

	var renderJSONError = function renderJSONError(error) {
		return (0, _react.createElement)('h2', null, 'JSON is invalid ' + error);
	};

	var renderSerializedJSON = _ramda2.default.tryCatch(_ramda2.default.pipe(JSON.parse, renderJSON), renderJSONError);

	var JSONComponent = _ramda2.default.converge(_ramda2.default.call, [_ramda2.default.ifElse(_ramda2.default.prop('isDeserialized'), _ramda2.default.always(renderJSON), _ramda2.default.always(renderSerializedJSON)), _ramda2.default.prop('json')]);

	exports.default = JSONComponent;

/***/ },
/* 77 */
/***/ function(module, exports, __webpack_require__) {

	var baseGetTag = __webpack_require__(55),
	    isObjectLike = __webpack_require__(68);

	/** `Object#toString` result references. */
	var numberTag = '[object Number]';

	/**
	 * Checks if `value` is classified as a `Number` primitive or object.
	 *
	 * **Note:** To exclude `Infinity`, `-Infinity`, and `NaN`, which are
	 * classified as numbers, use the `_.isFinite` method.
	 *
	 * @static
	 * @memberOf _
	 * @since 0.1.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is a number, else `false`.
	 * @example
	 *
	 * _.isNumber(3);
	 * // => true
	 *
	 * _.isNumber(Number.MIN_VALUE);
	 * // => true
	 *
	 * _.isNumber(Infinity);
	 * // => true
	 *
	 * _.isNumber('3');
	 * // => false
	 */
	function isNumber(value) {
	  return typeof value == 'number' ||
	    (isObjectLike(value) && baseGetTag(value) == numberTag);
	}

	module.exports = isNumber;


/***/ },
/* 78 */
/***/ function(module, exports, __webpack_require__) {

	var baseGetTag = __webpack_require__(55),
	    isObjectLike = __webpack_require__(68);

	/** `Object#toString` result references. */
	var boolTag = '[object Boolean]';

	/**
	 * Checks if `value` is classified as a boolean primitive or object.
	 *
	 * @static
	 * @memberOf _
	 * @since 0.1.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is a boolean, else `false`.
	 * @example
	 *
	 * _.isBoolean(false);
	 * // => true
	 *
	 * _.isBoolean(null);
	 * // => false
	 */
	function isBoolean(value) {
	  return value === true || value === false ||
	    (isObjectLike(value) && baseGetTag(value) == boolTag);
	}

	module.exports = isBoolean;


/***/ },
/* 79 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/destinations/components/CollectedImage.js';

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var CollectedImage = _react2.default.createClass({
		displayName: 'CollectedImage',
		getInitialState: function getInitialState() {
			return {
				html: null
			};
		},
		componentWillMount: function componentWillMount() {
			window.promiseCollectedImageURL(this.props).then(this.onLoad, this.onError);
		},
		onLoad: function onLoad(result) {
			this.setState(result);
		},
		onError: function onError(error) {
			this.setState({ error: error });
		},
		render: function render() {
			var text = this.props.text;
			var _state = this.state,
			    html = _state.html,
			    error = _state.error;


			if (html) {
				return _react2.default.createElement('div', { dangerouslySetInnerHTML: { __html: html }, __source: {
						fileName: _jsxFileName,
						lineNumber: 29
					},
					__self: this
				});
			} else if (error) {
				return _react2.default.createElement('div', { children: 'Error: ' + error.message, __source: {
						fileName: _jsxFileName,
						lineNumber: 34
					},
					__self: this
				});
			}

			return text;
		}
	});

	exports.default = CollectedImage;

/***/ },
/* 80 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/destinations/components/UnsplashImage.js';

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _repeat = __webpack_require__(49);

	var _repeat2 = _interopRequireDefault(_repeat);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var unsplashURLForKeywords = _ramda2.default.pipe(_ramda2.default.ifElse(_ramda2.default.is(String), function (keywords) {
		return '/800x600?' + keywords;
	}, _ramda2.default.always('/800x600?')), _ramda2.default.concat('https://source.unsplash.com'));

	var UnsplashImage = _react2.default.createClass({
		displayName: 'UnsplashImage',
		getInitialState: function getInitialState() {
			return {
				refreshCount: 0
			};
		},
		onRefresh: function onRefresh() {
			this.setState(function (_ref) {
				var refreshCount = _ref.refreshCount;
				return {
					refreshCount: refreshCount + 1
				};
			});
		},
		render: function render() {
			var _props = this.props,
			    category = _props.category,
			    text = _props.text;
			var refreshCount = this.state.refreshCount;

			var url = '' + unsplashURLForKeywords(category) + (0, _repeat2.default)(',', refreshCount);
			return _react2.default.createElement('img', { key: refreshCount, src: url, alt: text,
				style: { width: '100%', height: 'auto' },
				onClick: this.onRefresh,
				__source: {
					fileName: _jsxFileName,
					lineNumber: 32
				},
				__self: this
			});
		}
	});

	exports.default = UnsplashImage;

/***/ },
/* 81 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.useWithFallback = exports.commandline = exports.email = undefined;
	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/destinations/Message.js';

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactSeeds = __webpack_require__(7);

	var _reactSeeds2 = _interopRequireDefault(_reactSeeds);

	var _multilinedText = __webpack_require__(74);

	var _multilinedText2 = _interopRequireDefault(_multilinedText);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var metaFontSize = 14;

	function MetaPair(_ref) {
		var title = _ref.title,
		    content = _ref.content,
		    resolveContent = _ref.resolveContent;

		if (!content) {
			return _react2.default.createElement('noscript', {
				__source: {
					fileName: _jsxFileName,
					lineNumber: 11
				},
				__self: this
			});
		}

		return _react2.default.createElement(
			_reactSeeds.Seed,
			{ Component: 'dl',
				row: true,
				margin: { bottom: '0.5em' },
				__source: {
					fileName: _jsxFileName,
					lineNumber: 15
				},
				__self: this
			},
			_react2.default.createElement(_reactSeeds.Seed, { Component: 'dt',
				children: title,
				margin: { right: '0.5em' },
				font: { size: metaFontSize, weight: 'bold' },
				__source: {
					fileName: _jsxFileName,
					lineNumber: 19
				},
				__self: this
			}),
			_react2.default.createElement(_reactSeeds.Seed, { Component: 'dd',
				children: resolveContent(content),
				font: { size: metaFontSize },
				__source: {
					fileName: _jsxFileName,
					lineNumber: 24
				},
				__self: this
			})
		);
	}

	function EmailParagraph(_ref2) {
		var children = _ref2.children;

		return _react2.default.createElement('p', { style: { marginBottom: '1.3em' }, children: children, __source: {
				fileName: _jsxFileName,
				lineNumber: 34
			},
			__self: this
		});
	}

	var email = exports.email = function email(tags, references, text, children, Element, resolveContent) {
		return _react2.default.createElement(
			_reactSeeds.Seed,
			{ width: '90%',
				margin: 'auto',
				padding: { top: '0.5em', base: '1em' },
				text: { align: 'left' },
				boxShadow: '0 2px 8px #bbb',
				__source: {
					fileName: _jsxFileName,
					lineNumber: 39
				},
				__self: undefined
			},
			_react2.default.createElement(MetaPair, { resolveContent: resolveContent,
				title: 'From',
				content: tags.from || { text: 'hello@yourservice.com' },
				__source: {
					fileName: _jsxFileName,
					lineNumber: 45
				},
				__self: undefined
			}),
			_react2.default.createElement(MetaPair, { resolveContent: resolveContent,
				title: 'To',
				content: tags.to || { text: 'user@example.com' },
				__source: {
					fileName: _jsxFileName,
					lineNumber: 49
				},
				__self: undefined
			}),
			_react2.default.createElement(
				_reactSeeds.Seed,
				{ margin: { top: '1em' }, __source: {
						fileName: _jsxFileName,
						lineNumber: 53
					},
					__self: undefined
				},
				(0, _multilinedText2.default)(resolveContent({ text: text, references: references }), EmailParagraph)
			)
		);
	};

	var commandline = exports.commandline = function commandline(tags, references, text, children, Element, resolveContent) {
		return _react2.default.createElement(
			_reactSeeds.Seed,
			{ width: '90%',
				margin: 'auto',
				padding: '1em',
				text: { align: 'left', color: 'white' },
				font: { family: 'monospace' },
				background: { color: '#1f1f1f' },
				boxShadow: '0 2px 8px #bbb',
				__source: {
					fileName: _jsxFileName,
					lineNumber: 65
				},
				__self: undefined
			},
			_react2.default.createElement(
				_reactSeeds.Seed,
				{ margin: 'auto', __source: {
						fileName: _jsxFileName,
						lineNumber: 73
					},
					__self: undefined
				},
				resolveContent({ text: text, references: references })
			)
		);
	};

	var hasAll = _ramda2.default.pipe(_ramda2.default.map(_ramda2.default.has), _ramda2.default.allPass);

	var useWithFallback = exports.useWithFallback = function useWithFallback(fallback) {
		return _ramda2.default.cond([[hasAll(['message', 'email']), _ramda2.default.curry(email)], [_ramda2.default.has('commandline'), _ramda2.default.curry(commandline)], [_ramda2.default.T, fallback]]);
	};

/***/ },
/* 82 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.useWithFallback = exports.swatch = exports.srgbItem = undefined;
	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/destinations/Swatch.js';

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactSeeds = __webpack_require__(7);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var hexColorRegex = /^[a-fA-F0-9]{3,6}$/;
	var defaultSwatchSize = 32;

	var parseColorValue = function parseColorValue() {
		var alpha = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
		return _ramda2.default.ifElse(_ramda2.default.test(hexColorRegex), function (value) {
			return '#' + value;
		}, _ramda2.default.pipe(_ramda2.default.split(/[,]?\s+/), _ramda2.default.cond([[_ramda2.default.propEq('length', 1), _ramda2.default.pipe(_ramda2.default.head, _ramda2.default.repeat(_ramda2.default.__, 3), _ramda2.default.append(alpha))], [_ramda2.default.propEq('length', 3), _ramda2.default.append(alpha)], [_ramda2.default.T, _ramda2.default.identity]]), _ramda2.default.join(','), function (value) {
			return 'rgba(' + value + ')';
		}));
	};

	var parseAlpha = _ramda2.default.pipe(parseFloat, _ramda2.default.when(isNaN, function () {}));

	var srgbItem = exports.srgbItem = function srgbItem(value, alpha, minWidth, minHeight) {
		return _react2.default.createElement(_reactSeeds.Seed, {
			minWidth: minWidth,
			minHeight: minHeight,
			background: {
				color: parseColorValue(alpha)(value)
			},
			__source: {
				fileName: _jsxFileName,
				lineNumber: 42
			},
			__self: undefined
		});
	};

	var swatch = exports.swatch = function swatch(tags, references, text, children, Element, resolveContent, _ref) {
		var elementFromText = _ref.elementFromText;

		var alpha = parseAlpha(resolveContent(tags.alpha));
		var minWidth = _ramda2.default.cond([[_ramda2.default.has('width'), _ramda2.default.pipe(_ramda2.default.prop('width'), resolveContent)], [_ramda2.default.has('size'), _ramda2.default.pipe(_ramda2.default.prop('size'), resolveContent)], [_ramda2.default.T, _ramda2.default.always(defaultSwatchSize)]])(tags);
		var minHeight = _ramda2.default.cond([[_ramda2.default.has('height'), _ramda2.default.pipe(_ramda2.default.prop('height'), resolveContent)], [_ramda2.default.has('size'), _ramda2.default.pipe(_ramda2.default.prop('size'), resolveContent)], [_ramda2.default.T, _ramda2.default.always(defaultSwatchSize)]])(tags);

		var content = resolveContent({ references: references, text: text });
		console.log('#swatch content', content);
		if (Array.isArray(content)) {
			children = content.map(elementFromText);
		}

		if (children.length > 0) {
			return _react2.default.createElement(
				_reactSeeds.Seed,
				{ row: true, wrap: true, alignItems: 'center', __source: {
						fileName: _jsxFileName,
						lineNumber: 76
					},
					__self: undefined
				},
				Element.renderArray({ defaultTags: tags }, children)
			);
		} else if (_ramda2.default.is(String, content)) {
			return srgbItem(content, alpha, minWidth, minHeight);
		} else {
			return _react2.default.createElement('noscript', {
				__source: {
					fileName: _jsxFileName,
					lineNumber: 87
				},
				__self: undefined
			});
		}
	};

	var useWithFallback = exports.useWithFallback = function useWithFallback(fallback) {
		return _ramda2.default.cond([[_ramda2.default.has('swatch'), _ramda2.default.curry(swatch)], [_ramda2.default.T, fallback]]);
	};

/***/ },
/* 83 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.useWithFallback = exports.distribution = undefined;
	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/destinations/Distribution.js';

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactSeeds = __webpack_require__(7);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var meanOf = function meanOf(numbers) {
		return _ramda2.default.sum(numbers) / numbers.length;
	};

	var medianOf = function medianOf(numbers) {
		var sorted = _ramda2.default.sortBy(_ramda2.default.identity, numbers);
		if (sorted.length % 2 == 1) {
			return sorted[(sorted.length - 1) / 2];
		} else {
			var secondIndex = sorted.length / 2;
			return (sorted[secondIndex - 1] + sorted[secondIndex]) / 2;
		}
	};

	var roundBy = function roundBy(number, precision) {
		var factor = Math.pow(10, precision);
		return Math.round(number * factor) / factor;
	};

	var distribution = exports.distribution = function distribution(tags, references, text, children, Element, resolveContent) {
		var numbers = _ramda2.default.map(_ramda2.default.pipe(resolveContent, parseFloat), children);
		console.log('numbers', numbers);
		return _react2.default.createElement(
			_reactSeeds.Seed,
			{ column: true, alignItems: 'center', __source: {
					fileName: _jsxFileName,
					lineNumber: 32
				},
				__self: undefined
			},
			_react2.default.createElement('div', { children: 'Mean: ' + roundBy(meanOf(numbers), 3), __source: {
					fileName: _jsxFileName,
					lineNumber: 33
				},
				__self: undefined
			}),
			_react2.default.createElement('div', { children: 'Median: ' + roundBy(medianOf(numbers), 3), __source: {
					fileName: _jsxFileName,
					lineNumber: 34
				},
				__self: undefined
			})
		);
	};

	var useWithFallback = exports.useWithFallback = function useWithFallback(fallback) {
		return _ramda2.default.cond([[_ramda2.default.anyPass([_ramda2.default.has('distribution'), _ramda2.default.has('mean'), _ramda2.default.has('average')]), _ramda2.default.curry(distribution)], [_ramda2.default.T, fallback]]);
	};

/***/ },
/* 84 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.useWithFallback = exports.howmany = exports.whatsize = undefined;
	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/destinations/LayoutCalculator.js';

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactSeeds = __webpack_require__(7);

	var _reactSeeds2 = _interopRequireDefault(_reactSeeds);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var Error = function Error(message) {
		return _react2.default.createElement(
			_reactSeeds.Seed,
			{ text: { color: 'red' }, __source: {
					fileName: _jsxFileName,
					lineNumber: 6
				},
				__self: undefined
			},
			message
		);
	};

	var whatsize = exports.whatsize = function whatsize(tags, references, text, children, Element, resolveContent) {
		if (_ramda2.default.isNil(tags.within)) {
			return Error('Add tag #within');
		} else if (_ramda2.default.isNil(tags.count)) {
			return Error('Add tag #count');
		}

		var within = parseFloat(resolveContent(tags.within));
		var count = parseFloat(resolveContent(tags.count));

		return _react2.default.createElement(
			_reactSeeds.Seed,
			{
				__source: {
					fileName: _jsxFileName,
					lineNumber: 23
				},
				__self: undefined
			},
			'Within ',
			within,
			' \xB7 Count ',
			count,
			' \xB7 Individual size = ',
			within / count
		);
	};

	var howmany = exports.howmany = function howmany(tags, references, text, children, Element, resolveContent) {
		if (_ramda2.default.isNil(tags.within)) {
			return Error('Add tag #within');
		} else if (_ramda2.default.isNil(tags.size)) {
			return Error('Add tag #size');
		}

		var within = parseFloat(resolveContent(tags.within));
		var size = parseFloat(resolveContent(tags.size));
		var count = within / size;
		var remainder = within % size;

		return _react2.default.createElement(
			_reactSeeds.Seed,
			{
				__source: {
					fileName: _jsxFileName,
					lineNumber: 43
				},
				__self: undefined
			},
			_react2.default.createElement(
				_reactSeeds.Seed,
				{ row: true, __source: {
						fileName: _jsxFileName,
						lineNumber: 44
					},
					__self: undefined
				},
				_react2.default.createElement(_reactSeeds.Seed, { basis: Math.floor(count) * size, background: { color: '#e41' }, height: '1rem', __source: {
						fileName: _jsxFileName,
						lineNumber: 45
					},
					__self: undefined
				}),
				_react2.default.createElement(_reactSeeds.Seed, { basis: remainder, background: { color: '#ed1' }, __source: {
						fileName: _jsxFileName,
						lineNumber: 46
					},
					__self: undefined
				})
			),
			'Within ',
			within,
			' \xB7 Size ',
			size,
			' \xB7 Count = ',
			count,
			' \xB7 Remainder = ',
			remainder
		);
	};

	var useWithFallback = exports.useWithFallback = function useWithFallback(fallback) {
		return _ramda2.default.cond([[_ramda2.default.has('whatsize'), _ramda2.default.curry(whatsize)], [_ramda2.default.has('howmany'), _ramda2.default.curry(howmany)], [_ramda2.default.T, fallback]]);
	};

/***/ },
/* 85 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.title = exports.Preview = exports.panel = exports.cta = exports.button = undefined;

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/destinations/Bootstrap.js';
	exports.head = head;

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactSeeds = __webpack_require__(7);

	var _reactSeeds2 = _interopRequireDefault(_reactSeeds);

	var _rgba = __webpack_require__(28);

	var _rgba2 = _interopRequireDefault(_rgba);

	var _assets = __webpack_require__(86);

	var assets = _interopRequireWildcard(_assets);

	var _Vanilla = __webpack_require__(48);

	var Vanilla = _interopRequireWildcard(_Vanilla);

	var _render = __webpack_require__(73);

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var buttonTagsToClass = _ramda2.default.uncurryN(3, function (resolveContent, contentIsTrue) {
		return _ramda2.default.converge(_ramda2.default.unapply(_ramda2.default.join(' ')), [_ramda2.default.always('btn'), _ramda2.default.cond([[contentIsTrue('primary'), _ramda2.default.always('btn-primary')],
		//[ contentIsTrue('link'), R.always('btn-link') ],
		[_ramda2.default.T, _ramda2.default.always('btn-default')]]), _ramda2.default.cond([[contentIsTrue('large'), _ramda2.default.always('btn-lg')], [contentIsTrue('small'), _ramda2.default.always('btn-sm')], [contentIsTrue('extrasmall'), _ramda2.default.always('btn-xs')], [_ramda2.default.T, _ramda2.default.always('')]])]);
	});

	var button = exports.button = function button(tags, mentions, texts, children, Element, resolveContent) {
		var contentIsTrue = _ramda2.default.propSatisfies(function (value) {
			return resolveContent(value, { single: true }) == true;
		});

		var Component = 'button';
		var url = void 0;
		if (_ramda2.default.has('link', tags)) {
			Component = 'a';
			url = resolveContent(tags.link);
		}

		var onClick = void 0;
		if (_ramda2.default.has('toggle', tags)) {
			onClick = function onClick() {
				resolveContent(tags.toggle, { alter: _ramda2.default.not });
			};
		}

		return _react2.default.createElement(Component, _extends({
			href: url
		}, (0, _reactSeeds2.default)({
			alignSelf: 'center',
			margin: { bottom: '0.5rem' },
			maxWidth: '20em'
		}), {
			className: buttonTagsToClass(resolveContent, contentIsTrue, tags),
			children: texts,
			onClick: onClick,
			__source: {
				fileName: _jsxFileName,
				lineNumber: 45
			},
			__self: undefined
		}));
	};
	var cta = exports.cta = button;

	var panelTagsToClass = _ramda2.default.uncurryN(3, function (resolveContent, contentIsTrue) {
		return _ramda2.default.converge(_ramda2.default.unapply(_ramda2.default.join(' ')), [_ramda2.default.always('panel'), _ramda2.default.cond([[contentIsTrue('primary'), _ramda2.default.always('panel-primary')], [contentIsTrue('success'), _ramda2.default.always('panel-success')], [contentIsTrue('info'), _ramda2.default.always('panel-info')], [contentIsTrue('warning'), _ramda2.default.always('panel-warning')], [contentIsTrue('danger'), _ramda2.default.always('panel-danger')], [_ramda2.default.T, _ramda2.default.always('panel-default')]])]);
	});

	var panel = exports.panel = function panel(tags, mentions, texts, children, Element, resolveContent) {
		var contentIsTrue = _ramda2.default.propSatisfies(function (value) {
			return resolveContent(value, true) == true;
		});

		return _react2.default.createElement(
			_reactSeeds.Seed,
			{ Component: 'div',
				className: panelTagsToClass(resolveContent, contentIsTrue, tags),
				alignSelf: 'center',
				margin: { bottom: '0.5rem' },
				maxWidth: '20em',
				__source: {
					fileName: _jsxFileName,
					lineNumber: 78
				},
				__self: undefined
			},
			_react2.default.createElement(
				'div',
				{ className: 'panel-heading', __source: {
						fileName: _jsxFileName,
						lineNumber: 84
					},
					__self: undefined
				},
				_react2.default.createElement('h2', { className: 'panel-title', children: texts, __source: {
						fileName: _jsxFileName,
						lineNumber: 85
					},
					__self: undefined
				})
			),
			_react2.default.createElement(
				'div',
				{ className: 'panel-body', __source: {
						fileName: _jsxFileName,
						lineNumber: 87
					},
					__self: undefined
				},
				children.map(function (element, index) {
					return _react2.default.createElement(Element, _extends({}, element, { key: index, __source: {
							fileName: _jsxFileName,
							lineNumber: 90
						},
						__self: undefined
					}));
				})
			)
		);
	};

	var elementRendererForTags = Vanilla.extendTagConds([[_ramda2.default.has('card'), _ramda2.default.curry(panel)], [_ramda2.default.has('panel'), _ramda2.default.curry(panel)], [_ramda2.default.has('button'), _ramda2.default.curry(button)], [_ramda2.default.has('cta'), _ramda2.default.curry(cta)]]);

	var Preview = exports.Preview = (0, _render.renderTreeUsing)({ elementRendererForTags: elementRendererForTags });

	var title = exports.title = 'Bootstrap 3';

	function head() {
		return [_react2.default.createElement('link', { key: 'css',
			rel: 'stylesheet', type: 'text/css',
			href: 'https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css',
			__source: {
				fileName: _jsxFileName,
				lineNumber: 111
			},
			__self: this
		}), _react2.default.createElement('script', { key: 'js',
			src: 'https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js',
			__source: {
				fileName: _jsxFileName,
				lineNumber: 115
			},
			__self: this
		})];
	}

/***/ },
/* 86 */
/***/ function(module, exports) {

	'use strict';

	exports.__esModule = true;
	exports.css = css;
	exports.cssScoped = cssScoped;
	exports.js = js;
	exports.remove = remove;
	function css(_ref) {
		var url = _ref.url,
		    id = _ref.id;

		if (document.getElementById(id)) {
			return;
		}

		var styleElement = document.createElement('link');
		styleElement.id = id;
		styleElement.rel = 'stylesheet';
		styleElement.type = 'text/css';
		styleElement.href = url;
		document.head.appendChild(styleElement);
	}

	function cssScoped(_ref2) {
		var url = _ref2.url,
		    id = _ref2.id,
		    scopeTo = _ref2.scopeTo;

		if (document.getElementById(id)) {
			return;
		}

		var styleElement = document.createElement('style');
		styleElement.id = id;
		styleElement.scoped = "scoped";
		styleElement.innerText = '@import "' + url + '";\n';
		scopeTo.appendChild(styleElement);
	}

	function js(_ref3) {
		var url = _ref3.url,
		    id = _ref3.id;

		if (document.getElementById(id)) {
			return;
		}

		var scriptElement = document.createElement('link');
		scriptElement.id = id;
		scriptElement.type = 'text/javascript';
		scriptElement.src = url;
		document.head.appendChild(scriptElement);
	}

	function remove(ids) {
		ids.forEach(function (id) {
			document.head.removeChild(document.getElementById(id));
		});
	}

/***/ },
/* 87 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.title = exports.Preview = exports.button = undefined;
	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/destinations/Foundation.js';
	exports.head = head;

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactSeeds = __webpack_require__(7);

	var _reactSeeds2 = _interopRequireDefault(_reactSeeds);

	var _rgba = __webpack_require__(28);

	var _rgba2 = _interopRequireDefault(_rgba);

	var _assets = __webpack_require__(86);

	var assets = _interopRequireWildcard(_assets);

	var _Vanilla = __webpack_require__(48);

	var Vanilla = _interopRequireWildcard(_Vanilla);

	var _render = __webpack_require__(73);

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var buttonTagsToClass = _ramda2.default.converge(_ramda2.default.unapply(_ramda2.default.join(' ')), [_ramda2.default.always('button'), _ramda2.default.cond([[_ramda2.default.has('secondary'), _ramda2.default.always('secondary')], [_ramda2.default.has('disabled'), _ramda2.default.always('disabled')], [_ramda2.default.T, _ramda2.default.always('')]]), _ramda2.default.cond([[_ramda2.default.has('large'), _ramda2.default.always('large')], [_ramda2.default.has('small'), _ramda2.default.always('small')], [_ramda2.default.has('extrasmall'), _ramda2.default.always('tiny')], [_ramda2.default.T, _ramda2.default.always('')]])]);

	var button = exports.button = function button(tags, mentions, texts) {
		return _react2.default.createElement(_reactSeeds.Seed, { Component: 'button',
			className: buttonTagsToClass(tags),
			alignSelf: 'center',
			margin: { bottom: '0.5rem' },
			maxWidth: '20em',
			children: texts,
			__source: {
				fileName: _jsxFileName,
				lineNumber: 29
			},
			__self: undefined
		});
	};

	var elementRendererForTags = Vanilla.extendTagConds([[_ramda2.default.has('button'), _ramda2.default.curry(button)], [_ramda2.default.has('cta'), _ramda2.default.curry(button)]]);

	var Preview = exports.Preview = (0, _render.renderTreeUsing)({ elementRendererForTags: elementRendererForTags });

	var title = exports.title = 'Foundation';

	function head() {
		return [_react2.default.createElement('link', { rel: 'stylesheet', type: 'text/css',
			href: 'https://cdnjs.cloudflare.com/ajax/libs/foundation/6.2.3/foundation-flex.min.css',
			__source: {
				fileName: _jsxFileName,
				lineNumber: 49
			},
			__self: this
		}), _react2.default.createElement('script', {
			src: 'https://cdnjs.cloudflare.com/ajax/libs/foundation/6.2.3/foundation.min.js',
			__source: {
				fileName: _jsxFileName,
				lineNumber: 52
			},
			__self: this
		})];
	}

/***/ },
/* 88 */
/***/ function(module, exports) {

	"use strict";

/***/ },
/* 89 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.title = exports.Preview = undefined;
	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/destinations/ReactCode.js';
	exports.head = head;

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactSeeds = __webpack_require__(7);

	var _reactSeeds2 = _interopRequireDefault(_reactSeeds);

	var _Vanilla = __webpack_require__(48);

	var Vanilla = _interopRequireWildcard(_Vanilla);

	var _render = __webpack_require__(73);

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var Code = function Code(_ref) {
		var children = _ref.children,
		    _ref$indent = _ref.indent,
		    indent = _ref$indent === undefined ? 0 : _ref$indent;
		return _react2.default.createElement(
			_reactSeeds.Seed,
			{ Component: 'pre',
				grow: 1, width: '100%',
				text: { align: 'left', whitespace: 'pre-wrap', color: 'white' },
				background: { color: '#191919' },
				__source: {
					fileName: _jsxFileName,
					lineNumber: 9
				},
				__self: undefined
			},
			_ramda2.default.repeat('  ', indent),
			children
		);
	};

	var field = function field(tags, references, text) {
		return _react2.default.createElement(
			Code,
			{
				__source: {
					fileName: _jsxFileName,
					lineNumber: 20
				},
				__self: undefined
			},
			'    <label\n      <span>' + text + '</span>\n      <input type=\'' + (Vanilla.isPassword(tags, text) ? 'password' : 'text') + '\' />\n    </label>\n'
		);
	};

	var button = function button(tag, mentions, text) {
		return _react2.default.createElement(Code, { children: '<button>' + text + '</button>', indent: 2, __source: {
				fileName: _jsxFileName,
				lineNumber: 32
			},
			__self: undefined
		});
	};

	var image = function image(tag, mentions, text) {
		return _react2.default.createElement(
			Code,
			{
				__source: {
					fileName: _jsxFileName,
					lineNumber: 36
				},
				__self: undefined
			},
			'    <figure>\n      <img src="...">\n      <figcaption>' + text + '</figcaption>\n    </figure>\n'
		);
	};

	var text = function text(tag, mentions, _text, children) {
		return _react2.default.createElement(
			Code,
			{ children: '<span>' + (mentions[0] || _text) + '</span>', indent: 2, __source: {
					fileName: _jsxFileName,
					lineNumber: 47
				},
				__self: undefined
			},
			'<span>',
			_ramda2.default.ifElse(_ramda2.default.isNil, _ramda2.default.always(_text), function (mentionName) {
				return '{ ' + mentionName + ' }';
			})(mentions[0]),
			'</span>'
		);
	};

	var elementRendererForTags = _ramda2.default.cond([[_ramda2.default.has('field'), _ramda2.default.curry(field)], [_ramda2.default.has('button'), _ramda2.default.curry(button)], [_ramda2.default.has('cta'), _ramda2.default.curry(button)], [_ramda2.default.has('image'), _ramda2.default.curry(image)],
	// [ R.has('video'), R.curry(Web.video) ],
	[_ramda2.default.has('text'), _ramda2.default.curry(text)],
	// [ R.has('swatch'), R.curry(Web.swatch) ],
	// [ R.has('nav'), R.curry(Web.nav) ],
	// [ R.has('columns'), R.curry(Web.columns) ],
	// [ R.has('list'), R.curry(Web.list) ],
	[_ramda2.default.T, _ramda2.default.curry(text)]]);

	function Section(_ref2) {
		var children = _ref2.children;

		return _react2.default.createElement(_reactSeeds.Seed, { children: children, __source: {
				fileName: _jsxFileName,
				lineNumber: 76
			},
			__self: this
		});
	}

	function Master(_ref3) {
		var children = _ref3.children,
		    ingredients = _ref3.ingredients;

		var ingredientIDs = _ramda2.default.pipe(_ramda2.default.keys, _ramda2.default.join(', '))(ingredients);

		return _react2.default.createElement(
			_reactSeeds.Seed,
			{
				__source: {
					fileName: _jsxFileName,
					lineNumber: 87
				},
				__self: this
			},
			_react2.default.createElement(Code, { children: 'function Component({ ' + ingredientIDs + ' }) {', __source: {
					fileName: _jsxFileName,
					lineNumber: 88
				},
				__self: this
			}),
			_react2.default.createElement(Code, { children: 'return (', indent: 1, __source: {
					fileName: _jsxFileName,
					lineNumber: 89
				},
				__self: this
			}),
			children,
			_react2.default.createElement(Code, { children: ')', indent: 1, __source: {
					fileName: _jsxFileName,
					lineNumber: 93
				},
				__self: this
			}),
			_react2.default.createElement(Code, { children: '}', __source: {
					fileName: _jsxFileName,
					lineNumber: 94
				},
				__self: this
			})
		);
	}

	var Preview = exports.Preview = _ramda2.default.pipe((0, _render.renderTreeUsing)({
		elementRendererForTags: elementRendererForTags,
		Section: Section,
		Master: Master
	}));

	var title = exports.title = 'React Code';

	function head() {
		return _react2.default.createElement('head', {
			__source: {
				fileName: _jsxFileName,
				lineNumber: 111
			},
			__self: this
		});
	}

/***/ },
/* 90 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.head = exports.title = exports.Preview = undefined;
	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/destinations/Records.js';

	var _Raw = __webpack_require__(91);

	Object.defineProperty(exports, 'head', {
		enumerable: true,
		get: function get() {
			return _Raw.head;
		}
	});

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _JSONComponent = __webpack_require__(76);

	var _JSONComponent2 = _interopRequireDefault(_JSONComponent);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var toRecord = _ramda2.default.converge(_ramda2.default.call, [_ramda2.default.pipe(_ramda2.default.prop('children'), _ramda2.default.ifElse(_ramda2.default.isEmpty, function () {
		return withContent;
	}, function (children) {
		return withChildren(children);
	})), _ramda2.default.prop('text'), _ramda2.default.pipe(_ramda2.default.prop('tags'),
	//R.filter(R.equals(true)),
	_ramda2.default.keys)]);

	var withContent = _ramda2.default.curry(function (content, tags) {
		return _ramda2.default.ifElse(_ramda2.default.isEmpty, _ramda2.default.always(content), _ramda2.default.pipe(_ramda2.default.reverse, _ramda2.default.reduce(_ramda2.default.flip(_ramda2.default.objOf), content)))(tags);
	});

	var withChildren = _ramda2.default.curry(function (children, content, tags) {
		return withContent(_ramda2.default.map(toRecord, children), tags);
	});

	// TODO: references, arrays with children
	var toRecords = _ramda2.default.map(_ramda2.default.pipe(_ramda2.default.map(toRecord), _ramda2.default.ifElse(_ramda2.default.propSatisfies(_ramda2.default.gt(_ramda2.default.__, 1), 'length'), _ramda2.default.pipe(_ramda2.default.map(_ramda2.default.when(_ramda2.default.is(String), _ramda2.default.objOf('content'))), _ramda2.default.mergeAll), _ramda2.default.head)));

	var Preview = exports.Preview = function Preview(_ref) {
		var ingredients = _ref.ingredients,
		    contentTree = _ref.contentTree;
		return _react2.default.createElement(_JSONComponent2.default, { json: toRecords(contentTree), isDeserialized: true, __source: {
				fileName: _jsxFileName,
				lineNumber: 63
			},
			__self: undefined
		});
	};

	var title = exports.title = 'Records';

/***/ },
/* 91 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.title = exports.Preview = undefined;
	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/destinations/Raw.js';
	exports.head = head;

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactSeeds = __webpack_require__(7);

	var _reactSeeds2 = _interopRequireDefault(_reactSeeds);

	var _rgba = __webpack_require__(28);

	var _rgba2 = _interopRequireDefault(_rgba);

	var _JSONComponent = __webpack_require__(76);

	var _JSONComponent2 = _interopRequireDefault(_JSONComponent);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var Preview = exports.Preview = function Preview(_ref) {
		var ingredients = _ref.ingredients,
		    contentTree = _ref.contentTree;
		return _react2.default.createElement(_JSONComponent2.default, { json: contentTree, isDeserialized: true, __source: {
				fileName: _jsxFileName,
				lineNumber: 10
			},
			__self: undefined
		});
	};

	var title = exports.title = 'Raw';

	var styleSheet = '\nhtml {\n\tfont-size: 18px;\n\tfont-size: calc(112.5% + 2 * (100vw - 600px) / 400);\n\tbackground-color: #eef8f8;\n\tcolor: #027362;\n}\n\nbody {\n\tbox-sizing: border-box;\n\tmax-width: 100vw;\n\tmargin: auto;\n\tpadding: 1.333333333rem 1.7em;\n\tline-height: ' + 4 / 3 + 'rem;\n\tfont-family: system, "-apple-system", "-webkit-system-font", BlinkMacSystemFont, "Helvetica Neue", "Helvetica", "Segoe UI", "Roboto", "Arial", "freesans", sans-serif, "Apple Color Emoji", "Segoe UI Emoji", "Segoe UI Symbol";\n\t-webkit-hypens: auto; -ms-hypens: auto; hypens: auto;\n}\n\n* {\n\tmargin: auto;\n}\n\np,\nul,\nol,\ndt,\npre,\nhr {\n\tmargin-bottom: ' + 2 / 3 + 'rem;\n}\n\nol {\n\tpadding-left: 2rem;\n}\n\nli {\n\tmargin-bottom: ' + 4 / 3 + 'rem;\n}\n\ndl,\ndd {\n\tmargin: auto;\n\twidth: auto;\n}\n\ndt {\n\tmargin-bottom: 0;\n\tfont-weight: bold;\n}\ndd {\n\tmargin-left: 1em;\n\tmargin-right: 0;\n}\n';

	function head() {
		return _react2.default.createElement(
			'head',
			{
				__source: {
					fileName: _jsxFileName,
					lineNumber: 72
				},
				__self: this
			},
			_react2.default.createElement('style', { children: styleSheet, __source: {
					fileName: _jsxFileName,
					lineNumber: 73
				},
				__self: this
			})
		);
	}

/***/ },
/* 92 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.errorFieldBackground = exports.ingredient = exports.source = exports.lightKeyB = exports.lightKeyA = exports.light = exports.light1mid = exports.mid = exports.dark = undefined;

	var _rgba = __webpack_require__(28);

	var _rgba2 = _interopRequireDefault(_rgba);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	// http://colorizer.org

	var dark = exports.dark = '#292929';
	var mid = exports.mid = '#555';
	var light1mid = exports.light1mid = '#eee';
	var light = exports.light = '#f8f8f8';
	var lightKeyA = exports.lightKeyA = '#FBF9ED';
	var lightKeyB = exports.lightKeyB = '#B0E4FF';

	//export const sourceBackground = '#DBDCF2'
	//export const sourceText = '#343647' //'#454872'

	var source = exports.source = {
		text: '#003972',
		background: '#bee6ff',
		border: '#afd7f0'
	};

	/*
	export const ingredient = {
		field: {
			text: '#531900',
			background: '#ffe7be',
			border: '#ffd9b0'
		},
		button: {
			normal: {
				text: '#531900',
				background: '#ffd9b0',
				border: '#f4bf97'
			},
			selected: {
				text: '#ffbb98',
				background: '#531900',
				border: '#490f00'
			}
		}
	}
	*/

	var ingredient = exports.ingredient = {
		field: {
			text: '#582b01',
			background: '#fff4bf',
			border: '#ffe9b1'
		},
		button: {
			normal: {
				text: '#582b01',
				background: '#ffe9b1',
				border: '#fbd398'
			},
			selected: {
				text: '#ffe9b1',
				background: '#582b01',
				border: '#4e1e00'
			}
		}
	};

	var errorFieldBackground = exports.errorFieldBackground = (0, _rgba2.default)(255, 220, 220);

/***/ },
/* 93 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.masterButton = exports.ingredientButton = exports.ingredientIDField = exports.ingredientContentField = exports.markdownField = exports.recordField = exports.sourceField = exports.previewColumn = exports.mainColumn = undefined;

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	var _reactSeeds = __webpack_require__(7);

	var _reactSeeds2 = _interopRequireDefault(_reactSeeds);

	var _rgba = __webpack_require__(28);

	var _rgba2 = _interopRequireDefault(_rgba);

	var _colors = __webpack_require__(92);

	var colors = _interopRequireWildcard(_colors);

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var mainColumn = exports.mainColumn = (0, _reactSeeds2.default)({
		//basis: '49%',
		grow: 0,
		shrink: 0,
		width: 320,
		margin: { left: '0.5%', right: '0.5%' }
		//padding: { top: '1rem' }
	});

	var previewColumn = exports.previewColumn = function previewColumn(_ref) {
		var destinationDevice = _ref.destinationDevice;
		return {
			zIndex: 1,
			grow: 1,
			shrink: 0,
			basis: 'calc(100vw - 320px)',
			minWidth: 320,
			maxWidth: destinationDevice === 'phone' && 414,
			margin: { right: 5 },
			boxShadow: '0 0 10px ' + _rgba2.default.whiteValue(0, 0.333)
		};
	};

	var sourceField = exports.sourceField = {
		column: true,
		width: '100%',
		padding: '1rem',
		font: { size: 16 },
		text: { color: colors.source.text },
		background: { color: colors.source.background },
		border: { width: 1, style: 'solid', color: colors.source.border }
	};

	var recordField = exports.recordField = {
		width: '100%',
		padding: '0.5rem',
		font: { size: 16 },
		//text: { color: colors.light },
		background: { color: colors.lightKeyB },
		border: 'none'
	};

	var markdownField = exports.markdownField = {
		column: true,
		width: '100%',
		padding: '1rem',
		font: { size: 16 },
		//text: { color: colors.light },
		background: { color: colors.lightKeyB },
		border: { width: 1, style: 'solid', color: colors.light1mid }
	};

	var ingredientContentField = exports.ingredientContentField = function ingredientContentField(_ref2) {
		var error = _ref2.error;
		return {
			padding: '0.5rem',
			font: { size: 16 },
			text: { align: 'left', color: colors.ingredient.field.text },
			background: { color: error != null ? colors.errorFieldBackground : colors.ingredient.field.background },
			border: { width: 1, style: 'solid', color: colors.ingredient.field.border }
		};
	};

	var ingredientIDField = exports.ingredientIDField = _ramda2.default.evolve({
		font: _ramda2.default.merge({ weight: 'bold' })
	}, ingredientContentField({}));

	var ingredientButton = exports.ingredientButton = function ingredientButton(_ref3) {
		var selected = _ref3.selected;

		var buttonColors = colors.ingredient.button[selected ? 'selected' : 'normal'];
		return {
			text: { color: buttonColors.text },
			background: { color: buttonColors.background },
			border: { width: 1, style: 'solid', color: buttonColors.border }
		};
	};

	var masterButton = exports.masterButton = function masterButton(_ref4) {
		var selected = _ref4.selected;
		return {
			padding: { left: '0.5em', right: '0.5em' },
			text: { color: selected ? colors.lightKeyB : colors.light },
			background: { color: colors.dark }
		};
	};

/***/ },
/* 94 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/ui/Button.js';

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactSeeds = __webpack_require__(7);

	var _reactSeeds2 = _interopRequireDefault(_reactSeeds);

	var _default = __webpack_require__(95);

	var _default2 = _interopRequireDefault(_default);

	var _colors = __webpack_require__(92);

	var colors = _interopRequireWildcard(_colors);

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

	var fontSizeForProps = function fontSizeForProps(props) {
		return props.huge ? 21 : props.small ? 14 : 16;
	};

	exports.default = function (_ref) {
		var huge = _ref.huge,
		    small = _ref.small,
		    selected = _ref.selected,
		    _ref$padding = _ref.padding,
		    padding = _ref$padding === undefined ? 0 : _ref$padding,
		    _ref$styler = _ref.styler,
		    styler = _ref$styler === undefined ? _default2.default : _ref$styler,
		    props = _objectWithoutProperties(_ref, ['huge', 'small', 'selected', 'padding', 'styler']);

		return _react2.default.createElement(_reactSeeds.Seed, _extends({ Component: 'button'
		}, props, {
			padding: padding,
			font: { size: fontSizeForProps({ huge: huge, small: small }) },
			text: { color: selected ? colors.light : colors.dark },
			background: { color: selected ? colors.dark : colors.light },
			border: 'none',
			cornerRadius: 0
		}, styler({ selected: selected }), {
			styler: styler,
			__source: {
				fileName: _jsxFileName,
				lineNumber: 23
			},
			__self: undefined
		}));
	};

/***/ },
/* 95 */
/***/ function(module, exports) {

	module.exports = function defaultStyler(props) {
		var output = {};

		if (props.children) {
			output.children = props.children;
		}

		return output;
	};

/***/ },
/* 96 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/ui/Field.js';

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactDom = __webpack_require__(3);

	var _reactSeeds = __webpack_require__(7);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function sizeTextAreaToFit(el) {
		var style = el.style;

		style.height = '1px';

		var measuredHeight = el.scrollHeight + 'px';
		style.height = measuredHeight;
		style.resize = 'none';
	}

	exports.default = _react2.default.createClass({
		displayName: 'Field',
		setElement: function setElement(component) {
			var el = (0, _reactDom.findDOMNode)(component);

			this.el = el;

			if (el != null) {
				// null when unmounting
				sizeTextAreaToFit(el);
			}
		},
		onChange: function onChange(event) {
			var el = event.target;

			sizeTextAreaToFit(el);

			var value = el.value;
			this.props.onChange(value);
		},
		render: function render() {
			return _react2.default.createElement(_reactSeeds.Seed, _extends({ Component: 'textarea',
				ref: this.setElement
			}, this.props, {
				onChange: this.onChange,
				__source: {
					fileName: _jsxFileName,
					lineNumber: 36
				},
				__self: this
			}));
		},
		componentDidUpdate: function componentDidUpdate() {
			if (this.el) {
				sizeTextAreaToFit(this.el);
			}
		}
	});

/***/ },
/* 97 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/ui/Choice.js';

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactSeeds = __webpack_require__(7);

	var _reactSeeds2 = _interopRequireDefault(_reactSeeds);

	var _default = __webpack_require__(95);

	var _default2 = _interopRequireDefault(_default);

	var _colors = __webpack_require__(92);

	var colors = _interopRequireWildcard(_colors);

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

	var Choice = _react2.default.createClass({
		displayName: 'Choice',
		getDefaultProps: function getDefaultProps() {
			return {
				styler: function styler() {
					return _default2.default;
				}
			};
		},
		onChange: function onChange(event) {
			var el = event.target;
			var value = el.value;
			this.props.onChange(value);
		},
		render: function render() {
			var _this = this;

			var _props = this.props,
			    value = _props.value,
			    items = _props.items,
			    onChange = _props.onChange,
			    styler = _props.styler,
			    rest = _objectWithoutProperties(_props, ['value', 'items', 'onChange', 'styler']);

			return _react2.default.createElement(
				_reactSeeds.Seed,
				_extends({ Component: 'select'
				}, rest, {
					value: value,
					onChange: this.onChange,
					padding: { top: 0, bottom: 0, left: '0.5em', right: '0.5em' },
					font: { size: 16 },
					cornerRadius: 0
				}, (0, _reactSeeds.appearanceNone)(), styler(rest), {
					__source: {
						fileName: _jsxFileName,
						lineNumber: 24
					},
					__self: this
				}),
				items.map(function (_ref) {
					var value = _ref.value,
					    title = _ref.title;
					return _react2.default.createElement('option', { key: value,
						value: value, children: title,
						__source: {
							fileName: _jsxFileName,
							lineNumber: 36
						},
						__self: _this
					});
				})
			);
		}
	});

	exports.default = Choice;

/***/ },
/* 98 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/sections/IngredientsEditor.js';
	exports.default = IngredientsEditor;

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactSeeds = __webpack_require__(7);

	var _reactSeeds2 = _interopRequireDefault(_reactSeeds);

	var _mobxReact = __webpack_require__(25);

	var _Button = __webpack_require__(94);

	var _Button2 = _interopRequireDefault(_Button);

	var _Field = __webpack_require__(96);

	var _Field2 = _interopRequireDefault(_Field);

	var _Choice = __webpack_require__(97);

	var _Choice2 = _interopRequireDefault(_Choice);

	var _Tabs = __webpack_require__(99);

	var _Tabs2 = _interopRequireDefault(_Tabs);

	var _RecordEditor = __webpack_require__(100);

	var _RecordEditor2 = _interopRequireDefault(_RecordEditor);

	var _stylers = __webpack_require__(93);

	var stylers = _interopRequireWildcard(_stylers);

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var types = [{ value: 'text', title: 'Text' }, { value: 'image', title: 'Image' },
	//{ value: 'markdown', title: 'Markdown' },
	{ value: 'json', title: 'Record' },
	//{ value: 'csv', title: 'CSV' },
	//{ value: 'gist', title: 'Gist' },
	//{ value: 'icing', title: 'Icing' },
	//{ value: 'error', title: 'Error' },
	{ value: 'audience', title: 'Audience' }];

	var itemWidth = 270;
	var gutter = 5;

	var ReferenceHeading = function ReferenceHeading(props) {
		return _react2.default.createElement(_reactSeeds.Seed, _extends({ Component: 'h3',
			text: { align: 'center' }
		}, props, {
			__source: {
				fileName: _jsxFileName,
				lineNumber: 29
			},
			__self: undefined
		}));
	};

	var IngredientButton = function IngredientButton(props) {
		return _react2.default.createElement(_Button2.default, _extends({}, props, stylers.ingredientButton(props), {
			__source: {
				fileName: _jsxFileName,
				lineNumber: 36
			},
			__self: undefined
		}));
	};

	var RemoveButton = function RemoveButton(props) {
		return _react2.default.createElement(_Button2.default, _extends({ children: '\xD7', minWidth: 32, huge: true }, props, { styler: stylers.ingredientButton, __source: {
				fileName: _jsxFileName,
				lineNumber: 40
			},
			__self: undefined
		}));
	};

	var AddButton = function AddButton(props) {
		return _react2.default.createElement(_Button2.default, _extends({ children: 'Add ingredient\u2026',
			grow: 1,
			basis: itemWidth, minWidth: itemWidth, height: 32
		}, props, {
			styler: stylers.masterButton,
			__source: {
				fileName: _jsxFileName,
				lineNumber: 44
			},
			__self: undefined
		}));
	};

	var ReferenceActions = function ReferenceActions(_ref) {
		var onAddNew = _ref.onAddNew;
		return _react2.default.createElement(
			_reactSeeds.Seed,
			{ row: true,
				shrink: 0,
				basis: 100,
				margin: { left: gutter, right: gutter * 2 },
				__source: {
					fileName: _jsxFileName,
					lineNumber: 53
				},
				__self: undefined
			},
			_react2.default.createElement(AddButton, { onClick: onAddNew, __source: {
					fileName: _jsxFileName,
					lineNumber: 58
				},
				__self: undefined
			})
		);
	};

	var VariationTabs = function VariationTabs(_ref2) {
		var selectedIndex = _ref2.selectedIndex,
		    count = _ref2.count,
		    onSelect = _ref2.onSelect,
		    onAdd = _ref2.onAdd;
		return _react2.default.createElement(_Tabs2.default, {
			items: _ramda2.default.concat(_ramda2.default.times(function (index) {
				return {
					title: index + 1,
					selected: index === selectedIndex,
					onClick: function onClick() {
						return onSelect(index);
					}
				};
			}, count), { title: '+', onClick: onAdd }),
			buttonStyler: stylers.ingredientButton,
			__source: {
				fileName: _jsxFileName,
				lineNumber: 63
			},
			__self: undefined
		});
	};

	function ValidatingRecordEditor(_ref3) {
		var jsonString = _ref3.jsonString;

		try {
			return _react2.default.createElement(_RecordEditor2.default, { object: JSON.parse(jsonString), grow: 1, __source: {
					fileName: _jsxFileName,
					lineNumber: 81
				},
				__self: this
			});
		} catch (error) {
			return _react2.default.createElement('noscript', {
				__source: {
					fileName: _jsxFileName,
					lineNumber: 85
				},
				__self: this
			});
		}
	}

	var Brick = (0, _mobxReact.observer)(function Brick(_ref4) {
		var type = _ref4.type,
		    info = _ref4.info,
		    ingredientIndex = _ref4.ingredientIndex;

		return _react2.default.createElement(
			_reactSeeds.Seed,
			{ row: true, __source: {
					fileName: _jsxFileName,
					lineNumber: 95
				},
				__self: this
			},
			_react2.default.createElement(_Button2.default, {
				width: '1.35rem',
				children: info.result.error ? '!' : info.enabled ? '✓' : '·',
				styler: stylers.ingredientButton,
				onClick: function onClick() {
					info.toggleEnabled();
				},
				__source: {
					fileName: _jsxFileName,
					lineNumber: 96
				},
				__self: this
			}),
			type === 'json' ? _react2.default.createElement(ValidatingRecordEditor, { jsonString: info.rawContent, __source: {
					fileName: _jsxFileName,
					lineNumber: 105
				},
				__self: this
			}) : _react2.default.createElement(_Field2.default, _extends({ grow: 1,
				value: info.rawContent,
				onChange: function onChange(newRawContent) {
					info.rawContent = newRawContent;
				}
			}, stylers.ingredientContentField({ error: info.result.error }), {
				__source: {
					fileName: _jsxFileName,
					lineNumber: 107
				},
				__self: this
			})),
			_react2.default.createElement(_Button2.default, {
				width: '1.35rem',
				children: '\xB7\xB7\xB7',
				styler: stylers.ingredientButton,
				onClick: function onClick() {
					// Show menu with delete, convert to error
				},
				__source: {
					fileName: _jsxFileName,
					lineNumber: 115
				},
				__self: this
			})
		);
	});

	var Item = (0, _mobxReact.observer)(function Item(_ref5) {
		var _this = this;

		var ingredientIndex = _ref5.index,
		    ingredient = _ref5.ingredient,
		    ingredientIDToVariationIndex = _ref5.ingredientIDToVariationIndex,
		    onRemoveAtIndex = _ref5.onRemoveAtIndex,
		    onAddVariationAtIndex = _ref5.onAddVariationAtIndex,
		    onAddNew = _ref5.onAddNew;
		var id = ingredient.id,
		    type = ingredient.type,
		    variations = ingredient.variations;

		var selectedVariation = _ramda2.default.defaultTo(0, _ramda2.default.path([id], ingredientIDToVariationIndex));
		return _react2.default.createElement(
			_reactSeeds.Seed,
			{
				column: true,
				basis: itemWidth,
				width: itemWidth,
				margin: { left: gutter, right: gutter },
				__source: {
					fileName: _jsxFileName,
					lineNumber: 138
				},
				__self: this
			},
			_react2.default.createElement(
				_reactSeeds.Seed,
				{ row: true, __source: {
						fileName: _jsxFileName,
						lineNumber: 144
					},
					__self: this
				},
				_react2.default.createElement(_Field2.default, _extends({
					value: id,
					grow: 1,
					onChange: function onChange(newID) {
						console.log('newID', newID, ingredient);
						ingredient.id = newID;
					}
				}, stylers.ingredientIDField, {
					__source: {
						fileName: _jsxFileName,
						lineNumber: 145
					},
					__self: this
				})),
				_react2.default.createElement(_Choice2.default, {
					styler: stylers.ingredientButton,
					value: type, items: types,
					onChange: function onChange(newType) {
						ingredient.type = newType;
					},
					__source: {
						fileName: _jsxFileName,
						lineNumber: 154
					},
					__self: this
				}),
				_react2.default.createElement(RemoveButton, { onClick: function onClick() {
						onRemoveAtIndex(ingredientIndex);
					}, __source: {
						fileName: _jsxFileName,
						lineNumber: 161
					},
					__self: this
				})
			),
			variations.map(function (info, index) {
				return _react2.default.createElement(Brick, {
					type: type,
					info: info,
					ingredientIndex: ingredientIndex,
					__source: {
						fileName: _jsxFileName,
						lineNumber: 169
					},
					__self: _this
				});
			}),
			_react2.default.createElement(_Button2.default, {
				children: '+',
				onClick: function onClick() {
					ingredient.addNewVariation();
				},
				styler: stylers.ingredientButton,
				__source: {
					fileName: _jsxFileName,
					lineNumber: 176
				},
				__self: this
			})
		);
	});

	function IngredientsEditor(_ref6) {
		var _this2 = this;

		var ingredients = _ref6.ingredients,
		    ingredientIDToVariationIndex = _ref6.ingredientIDToVariationIndex,
		    onAddNew = _ref6.onAddNew,
		    onRemoveAtIndex = _ref6.onRemoveAtIndex,
		    onAddVariationAtIndex = _ref6.onAddVariationAtIndex;

		return _react2.default.createElement(
			_reactSeeds.Seed,
			{ row: true, __source: {
					fileName: _jsxFileName,
					lineNumber: 193
				},
				__self: this
			},
			ingredients.map(function (ingredient, index) {
				return _react2.default.createElement(Item, _extends({ key: index
				}, {
					index: index,
					ingredient: ingredient,
					ingredientIDToVariationIndex: ingredientIDToVariationIndex,
					onRemoveAtIndex: onRemoveAtIndex,
					onAddVariationAtIndex: onAddVariationAtIndex,
					onAddNew: onAddNew
				}, {
					__source: {
						fileName: _jsxFileName,
						lineNumber: 196
					},
					__self: _this2
				}));
			}),
			_react2.default.createElement(ReferenceActions, {
				onAddNew: onAddNew,
				__source: {
					fileName: _jsxFileName,
					lineNumber: 208
				},
				__self: this
			})
		);
	}

/***/ },
/* 99 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/ui/Tabs.js';

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactSeeds = __webpack_require__(7);

	var _reactSeeds2 = _interopRequireDefault(_reactSeeds);

	var _Button = __webpack_require__(94);

	var _Button2 = _interopRequireDefault(_Button);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

	function TabItem(_ref) {
		var title = _ref.title,
		    selected = _ref.selected,
		    onClick = _ref.onClick,
		    buttonStyler = _ref.buttonStyler;

		return _react2.default.createElement(_Button2.default, {
			children: title, selected: selected,
			grow: 1,
			height: 32,
			onClick: onClick,
			styler: buttonStyler,
			__source: {
				fileName: _jsxFileName,
				lineNumber: 11
			},
			__self: this
		});
	}

	function Tabs(_ref2) {
		var _this = this;

		var items = _ref2.items,
		    buttonStyler = _ref2.buttonStyler,
		    others = _objectWithoutProperties(_ref2, ['items', 'buttonStyler']);

		return _react2.default.createElement(
			_reactSeeds.Seed,
			_extends({ Component: 'nav', row: true }, others, {
				__source: {
					fileName: _jsxFileName,
					lineNumber: 23
				},
				__self: this
			}),
			items.map(function (item, index) {
				return _react2.default.createElement(TabItem, _extends({ key: index,
					buttonStyler: buttonStyler
				}, item, {
					__source: {
						fileName: _jsxFileName,
						lineNumber: 26
					},
					__self: _this
				}));
			})
		);
	}

	exports.default = Tabs;

/***/ },
/* 100 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/record/RecordEditor.js';
	exports.default = RecordEditor;

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactSeeds = __webpack_require__(7);

	var _Choice = __webpack_require__(97);

	var _Choice2 = _interopRequireDefault(_Choice);

	var _Field = __webpack_require__(96);

	var _Field2 = _interopRequireDefault(_Field);

	var _stylers = __webpack_require__(93);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

	var types = [{ value: 'string', title: 'Text' }, { value: 'boolean', title: 'Yes / No' }, { value: 'number', title: 'Number' }, { value: 'array', title: 'List' }, { value: 'object', title: 'Record' }];

	var valueEditorForType = _ramda2.default.cond([[_ramda2.default.equals('string'), _ramda2.default.always(function (string) {
	    return _react2.default.createElement(_Field2.default, _extends({ value: string }, _stylers.recordField, {
	        __source: {
	            fileName: _jsxFileName,
	            lineNumber: 17
	        },
	        __self: undefined
	    }));
	})], [_ramda2.default.equals('boolean'), _ramda2.default.always(function (boolean) {
	    return _react2.default.createElement(_Choice2.default, { value: boolean, items: [{ value: true, title: 'Yes' }, { value: false, title: ' No' }], __source: {
	            fileName: _jsxFileName,
	            lineNumber: 18
	        },
	        __self: undefined
	    });
	})], [_ramda2.default.equals('number'), _ramda2.default.always(function (number) {
	    return _react2.default.createElement('input', { type: 'number', value: number, __source: {
	            fileName: _jsxFileName,
	            lineNumber: 19
	        },
	        __self: undefined
	    });
	})], [_ramda2.default.equals('array'), function () {
	    return function (items) {
	        return _react2.default.createElement(
	            'div',
	            {
	                __source: {
	                    fileName: _jsxFileName,
	                    lineNumber: 20
	                },
	                __self: undefined
	            },
	            items.map(function (item, index) {
	                return _react2.default.createElement(Item, { key: index, id: index, value: item, __source: {
	                        fileName: _jsxFileName,
	                        lineNumber: 20
	                    },
	                    __self: undefined
	                });
	            })
	        );
	    };
	}], [_ramda2.default.equals('object'), function () {
	    return function (object) {
	        return _react2.default.createElement(RecordEditor, { object: object, __source: {
	                fileName: _jsxFileName,
	                lineNumber: 21
	            },
	            __self: undefined
	        });
	    };
	}]]);

	var valueEditorForValue = _ramda2.default.converge(_ramda2.default.call, [_ramda2.default.pipe(_ramda2.default.type, _ramda2.default.toLower, valueEditorForType), _ramda2.default.identity]);

	function Item(_ref) {
	    var id = _ref.id,
	        value = _ref.value;

	    return _react2.default.createElement(
	        _reactSeeds.Seed,
	        { column: true, __source: {
	                fileName: _jsxFileName,
	                lineNumber: 38
	            },
	            __self: this
	        },
	        _react2.default.createElement(
	            _reactSeeds.Seed,
	            { row: true, grow: 1, __source: {
	                    fileName: _jsxFileName,
	                    lineNumber: 39
	                },
	                __self: this
	            },
	            _react2.default.createElement('input', { value: id, style: { fontWeight: 'bold' }, __source: {
	                    fileName: _jsxFileName,
	                    lineNumber: 40
	                },
	                __self: this
	            }),
	            _react2.default.createElement(_Choice2.default, { value: _ramda2.default.type(value).toLowerCase(), items: types, __source: {
	                    fileName: _jsxFileName,
	                    lineNumber: 41
	                },
	                __self: this
	            })
	        ),
	        valueEditorForValue(value)
	    );
	}

	function RecordEditor(_ref2) {
	    var _this = this;

	    var object = _ref2.object,
	        seedProps = _objectWithoutProperties(_ref2, ['object']);

	    return _react2.default.createElement(
	        _reactSeeds.Seed,
	        _extends({ column: true }, seedProps, {
	            __source: {
	                fileName: _jsxFileName,
	                lineNumber: 50
	            },
	            __self: this
	        }),
	        Object.keys(object).map(function (key) {
	            return _react2.default.createElement(Item, { key: key,
	                id: key,
	                value: object[key],
	                __source: {
	                    fileName: _jsxFileName,
	                    lineNumber: 53
	                },
	                __self: _this
	            });
	        })
	    );
	}

/***/ },
/* 101 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _jsxFileName = '/Users/pgwsmith/Work/Royal Icing/gateau/src/sections/preview/index.js';
	exports.default = PreviewSection;

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactSeeds = __webpack_require__(7);

	var _reactSeeds2 = _interopRequireDefault(_reactSeeds);

	var _reactFrameComponent = __webpack_require__(102);

	var _reactFrameComponent2 = _interopRequireDefault(_reactFrameComponent);

	var _Button = __webpack_require__(94);

	var _Button2 = _interopRequireDefault(_Button);

	var _Choice = __webpack_require__(97);

	var _Choice2 = _interopRequireDefault(_Choice);

	var _stylers = __webpack_require__(93);

	var stylers = _interopRequireWildcard(_stylers);

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var catchRenderErrors = false;

	var iframeStyler = (0, _reactSeeds2.default)({
		//grow: 1,
		height: 600,
		border: 'none'
	});

	function DestinationChoice(_ref) {
		var destinationID = _ref.destinationID,
		    destinationDevice = _ref.destinationDevice,
		    destinations = _ref.destinations,
		    onChange = _ref.onChange,
		    onPhoneDestination = _ref.onPhoneDestination,
		    onFullDestination = _ref.onFullDestination;

		var items = _ramda2.default.pipe(_ramda2.default.toPairs, _ramda2.default.map(_ramda2.default.converge(_ramda2.default.merge, [_ramda2.default.pipe(_ramda2.default.prop(0), _ramda2.default.objOf('value')), _ramda2.default.pipe(_ramda2.default.prop(1), _ramda2.default.pick(['title']))])))(destinations);

		return _react2.default.createElement(
			_reactSeeds.Seed,
			{ row: true, width: '100%', __source: {
					fileName: _jsxFileName,
					lineNumber: 41
				},
				__self: this
			},
			_react2.default.createElement(_Choice2.default, {
				value: destinationID,
				items: items,
				width: '100%',
				minHeight: 32,
				grow: 1,
				border: 'none'
				//maxWidth='20em'
				, onChange: onChange,
				styler: stylers.masterButton,
				__source: {
					fileName: _jsxFileName,
					lineNumber: 42
				},
				__self: this
			}),
			_react2.default.createElement(_Button2.default, {
				onClick: onPhoneDestination,
				children: 'Phone',
				selected: destinationDevice == 'phone',
				styler: stylers.masterButton,
				__source: {
					fileName: _jsxFileName,
					lineNumber: 53
				},
				__self: this
			}),
			_react2.default.createElement(_Button2.default, {
				onClick: onFullDestination,
				children: 'Full',
				selected: destinationDevice == 'full',
				styler: stylers.masterButton,
				__source: {
					fileName: _jsxFileName,
					lineNumber: 59
				},
				__self: this
			})
		);
	}

	function PreviewSection(_ref2) {
		var _this = this;

		var contentTree = _ref2.contentTree,
		    ingredients = _ref2.ingredients,
		    destinationID = _ref2.destinationID,
		    destinationDevice = _ref2.destinationDevice,
		    destinations = _ref2.destinations,
		    onChangeDestination = _ref2.onChangeDestination,
		    onPhoneDestination = _ref2.onPhoneDestination,
		    onFullDestination = _ref2.onFullDestination;
		var _destinations$destina = destinations[destinationID],
		    renderHead = _destinations$destina.head,
		    Preview = _destinations$destina.Preview;


		return _react2.default.createElement(
			_reactSeeds.Seed,
			_extends({ column: true, alignItems: 'center'
			}, stylers.previewColumn({ destinationDevice: destinationDevice }), {
				__source: {
					fileName: _jsxFileName,
					lineNumber: 82
				},
				__self: this
			}),
			_react2.default.createElement(
				_reactSeeds.Seed,
				{ key: destinationID,
					column: true,
					grow: 1, width: '100%',
					__source: {
						fileName: _jsxFileName,
						lineNumber: 85
					},
					__self: this
				},
				!!contentTree ? false ? _ramda2.default.tryCatch(function (contentTree) {
					return _react2.default.createElement(Preview, {
						ingredients: ingredients,
						contentTree: contentTree,
						__source: {
							fileName: _jsxFileName,
							lineNumber: 94
						},
						__self: _this
					});
				}, function (error, contentTree) {
					return console.error('Invalid tree', error, contentTree);
				})(contentTree) : _react2.default.createElement(
					_reactFrameComponent2.default,
					_extends({
						head: renderHead()
					}, iframeStyler, {
						__source: {
							fileName: _jsxFileName,
							lineNumber: 102
						},
						__self: this
					}),
					_react2.default.createElement(Preview, {
						ingredients: ingredients,
						contentTree: contentTree,
						__source: {
							fileName: _jsxFileName,
							lineNumber: 106
						},
						__self: this
					})
				) : null
			),
			_react2.default.createElement(DestinationChoice, {
				destinationID: destinationID,
				destinationDevice: destinationDevice,
				destinations: destinations,
				onChange: onChangeDestination,
				onPhoneDestination: onPhoneDestination,
				onFullDestination: onFullDestination,
				__source: {
					fileName: _jsxFileName,
					lineNumber: 115
				},
				__self: this
			})
		);
	}

/***/ },
/* 102 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _Frame = __webpack_require__(103);

	var _Frame2 = _interopRequireDefault(_Frame);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.default = _Frame2.default;

/***/ },
/* 103 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _reactDom = __webpack_require__(3);

	var _reactDom2 = _interopRequireDefault(_reactDom);

	var _DocumentContext = __webpack_require__(104);

	var _DocumentContext2 = _interopRequireDefault(_DocumentContext);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	var hasConsole = typeof window !== 'undefined' && window.console;
	var noop = function noop() {};
	var swallowInvalidHeadWarning = noop;
	var resetWarnings = noop;

	if (hasConsole) {
	  (function () {
	    var originalError = console.error; // eslint-disable-line no-console
	    // Rendering a <head> into a body is technically invalid although it
	    // works. We swallow React's validateDOMNesting warning if that is the
	    // message to avoid confusion
	    swallowInvalidHeadWarning = function swallowInvalidHeadWarning() {
	      console.error = function (msg) {
	        // eslint-disable-line no-console
	        if (/<head>/.test(msg)) return;
	        originalError.call(console, msg);
	      };
	    };
	    resetWarnings = function resetWarnings() {
	      return console.error = originalError;
	    }; // eslint-disable-line no-console
	  })();
	}

	var Frame = function (_Component) {
	  _inherits(Frame, _Component);

	  // React warns when you render directly into the body since browser extensions
	  // also inject into the body and can mess up React. For this reason
	  // initialContent is expected to have a div inside of the body
	  // element that we render react into.
	  function Frame(props, context) {
	    _classCallCheck(this, Frame);

	    var _this = _possibleConstructorReturn(this, (Frame.__proto__ || Object.getPrototypeOf(Frame)).call(this, props, context));

	    _this._isMounted = false;
	    return _this;
	  }

	  _createClass(Frame, [{
	    key: 'componentDidMount',
	    value: function componentDidMount() {
	      this._isMounted = true;
	      this.renderFrameContents();
	    }
	  }, {
	    key: 'componentDidUpdate',
	    value: function componentDidUpdate() {
	      this.renderFrameContents();
	    }
	  }, {
	    key: 'componentWillUnmount',
	    value: function componentWillUnmount() {
	      this._isMounted = false;
	      var doc = this.getDoc();
	      if (doc) {
	        _reactDom2.default.unmountComponentAtNode(this.getMountTarget());
	      }
	    }
	  }, {
	    key: 'getDoc',
	    value: function getDoc() {
	      return _reactDom2.default.findDOMNode(this).contentDocument; // eslint-disable-line
	    }
	  }, {
	    key: 'getMountTarget',
	    value: function getMountTarget() {
	      var doc = this.getDoc();
	      if (this.props.mountTarget) {
	        return doc.querySelector(this.props.mountTarget);
	      }
	      return doc.body.children[0];
	    }
	  }, {
	    key: 'renderFrameContents',
	    value: function renderFrameContents() {
	      if (!this._isMounted) {
	        return;
	      }

	      var doc = this.getDoc();
	      if (doc && doc.readyState === 'complete') {
	        var win = doc.defaultView || doc.parentView;
	        var initialRender = !this._setInitialContent;
	        var contents = _react2.default.createElement(
	          _DocumentContext2.default,
	          { document: doc, window: win },
	          _react2.default.createElement(
	            'div',
	            { className: 'frame-content' },
	            this.props.head,
	            this.props.children
	          )
	        );

	        if (initialRender) {
	          doc.open();
	          doc.write(this.props.initialContent);
	          doc.close();
	          this._setInitialContent = true;
	        }

	        swallowInvalidHeadWarning();

	        // unstable_renderSubtreeIntoContainer allows us to pass this component as
	        // the parent, which exposes context to any child components.
	        var callback = initialRender ? this.props.contentDidMount : this.props.contentDidUpdate;
	        var mountTarget = this.getMountTarget();

	        _reactDom2.default.unstable_renderSubtreeIntoContainer(this, contents, mountTarget, callback);
	        resetWarnings();
	      } else {
	        setTimeout(this.renderFrameContents, 0);
	      }
	    }
	  }, {
	    key: 'render',
	    value: function render() {
	      var props = _extends({}, this.props, {
	        children: undefined // The iframe isn't ready so we drop children from props here. #12, #17
	      });
	      delete props.head;
	      delete props.initialContent;
	      delete props.mountTarget;
	      delete props.contentDidMount;
	      delete props.contentDidUpdate;
	      return _react2.default.createElement('iframe', props);
	    }
	  }]);

	  return Frame;
	}(_react.Component);

	Frame.propTypes = {
	  style: _react.PropTypes.object, // eslint-disable-line
	  head: _react.PropTypes.node,
	  initialContent: _react.PropTypes.string,
	  mountTarget: _react.PropTypes.string,
	  contentDidMount: _react.PropTypes.func,
	  contentDidUpdate: _react.PropTypes.func,
	  children: _react.PropTypes.oneOfType([_react.PropTypes.element, _react.PropTypes.arrayOf(_react.PropTypes.element)])
	};
	Frame.defaultProps = {
	  style: {},
	  head: null,
	  children: undefined,
	  mountTarget: undefined,
	  contentDidMount: function contentDidMount() {},
	  contentDidUpdate: function contentDidUpdate() {},
	  initialContent: '<!DOCTYPE html><html><head></head><body><div class="frame-root"></div></body></html>'
	};
	exports.default = Frame;

/***/ },
/* 104 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	// eslint-disable-line no-unused-vars

	var DocumentContext = function (_Component) {
	  _inherits(DocumentContext, _Component);

	  function DocumentContext() {
	    _classCallCheck(this, DocumentContext);

	    return _possibleConstructorReturn(this, (DocumentContext.__proto__ || Object.getPrototypeOf(DocumentContext)).apply(this, arguments));
	  }

	  _createClass(DocumentContext, [{
	    key: 'getChildContext',
	    value: function getChildContext() {
	      return {
	        document: this.props.document,
	        window: this.props.window
	      };
	    }
	  }, {
	    key: 'render',
	    value: function render() {
	      return _react.Children.only(this.props.children);
	    }
	  }]);

	  return DocumentContext;
	}(_react.Component);

	DocumentContext.propTypes = {
	  document: _react.PropTypes.object.isRequired,
	  window: _react.PropTypes.object.isRequired,
	  children: _react.PropTypes.element.isRequired
	};
	DocumentContext.childContextTypes = {
	  document: _react.PropTypes.object.isRequired,
	  window: _react.PropTypes.object.isRequired
	};
	exports.default = DocumentContext;

/***/ },
/* 105 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.default = createObservableStateManager;

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	var _mobx = __webpack_require__(24);

	var _parser = __webpack_require__(106);

	var _validateContent = __webpack_require__(112);

	var _validateContent2 = _interopRequireDefault(_validateContent);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var suggestReferenceFromTree = _ramda2.default.uncurryN(2, function (ingredients) {
		return _ramda2.default.pipe(_ramda2.default.chain(_ramda2.default.pluck('references')), _ramda2.default.unnest, _ramda2.default.map(_ramda2.default.head), // Just the requested ingredient ID
		_ramda2.default.difference(_ramda2.default.__, _ramda2.default.pluck('id', ingredients)), // Only IDs that are yet to be used
		_ramda2.default.head // First pick
		);
	});

	function createObservableIngredientVariation(ingredient, _ref) {
		var _ref$enabled = _ref.enabled,
		    enabled = _ref$enabled === undefined ? true : _ref$enabled,
		    rawContent = _ref.rawContent;

		return (0, _mobx.observable)({
			enabled: enabled,
			rawContent: rawContent,
			get result() {
				var transform = (0, _validateContent.transformerForType)(ingredient.type);
				return _ramda2.default.tryCatch(transform, _ramda2.default.objOf('error'))(this.rawContent);
			},
			toggleEnabled: (0, _mobx.action)(function () {
				this.enabled = !this.enabled;
			}),
			adjustRawContent: (0, _mobx.action)(function (adjuster) {
				this.rawContent = adjuster(this.rawContent);
			}),
			adjustContent: (0, _mobx.action)(function (adjuster) {
				var result = this.result;
				if (result.content) {
					adjuster(result.content);
					this.rawContent = (0, _validateContent.stringRepresenterForType)(ingredient.type, result.content);
				}
			}),
			editPath: (0, _mobx.action)(function (path, editor) {
				this.adjustContent(function (content) {
					var _ref2 = path.length == 1 ? [content, path[0]] : [_ramda2.default.path(initialPath, content), _ramda2.default.last(path)],
					    parent = _ref2[0],
					    key = _ref2[1];

					if (parent) {
						editor(parent, key);
					} else {
						// Warn user about incorrect key path?
					}
				});
			}),
			adjustPath: (0, _mobx.action)(function (path, adjuster) {
				this.editPath(path, function (parent, key) {
					parent[key] = adjuster(parent[key]);
				});
			})
		});
	}

	function createObservableIngredient(target) {
		return (0, _mobx.observable)({
			id: target.id,
			type: target.type,
			variations: target.variations.map(_ramda2.default.curry(createObservableIngredientVariation)(target)),
			addVariation: _mobx.action.bound(function (variation) {
				this.variations.push(createObservableIngredientVariation(this, variation));
			}),
			addNewVariation: _mobx.action.bound(function (variation) {
				this.addVariation({
					rawContent: ''
				});
			}),
			get flattenedResult() {
				var flattened = {
					type: this.type,
					variationReference: _ramda2.default.last(this.variations)
				};

				if (this.type == 'json') {
					flattened.content = this.variations.reduce(function (combined, variation) {
						// Use only if enabled
						if (!variation.enabled) {
							return combined;
						}
						// Skip if no content
						var result = variation.result;
						if (result.content == null) {
							return combined;
						}
						// Merge into combined JSON object
						return Object.assign(combined, result.content);
					}, {});
				} else {
					var variation = _ramda2.default.findLast(_ramda2.default.propEq('enabled', true), this.variations);
					if (variation) {
						flattened.content = variation.result.content;
					}
				}

				return flattened;
			}
		});
	}

	function createObservableStateManager() {
		var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
		    _ref3$content = _ref3.content,
		    content = _ref3$content === undefined ? '' : _ref3$content,
		    _ref3$destinationID = _ref3.destinationID,
		    destinationID = _ref3$destinationID === undefined ? 'foundation' : _ref3$destinationID,
		    _ref3$destinationDevi = _ref3.destinationDevice,
		    destinationDevice = _ref3$destinationDevi === undefined ? 'phone' : _ref3$destinationDevi,
		    _ref3$ingredients = _ref3.ingredients,
		    ingredients = _ref3$ingredients === undefined ? [] : _ref3$ingredients,
		    _ref3$scenarios = _ref3.scenarios,
		    scenarios = _ref3$scenarios === undefined ? [{}] : _ref3$scenarios,
		    _ref3$activeScenarioI = _ref3.activeScenarioIndex,
		    activeScenarioIndex = _ref3$activeScenarioI === undefined ? 0 : _ref3$activeScenarioI;

		return (0, _mobx.observable)({
			content: content,
			destinationID: destinationID,
			destinationDevice: destinationDevice,
			ingredients: ingredients.map(createObservableIngredient),
			scenarios: scenarios,
			activeScenarioIndex: activeScenarioIndex,

			get json() {
				return {
					body: this.content,
					ingredients: (0, _mobx.toJS)(this.ingredients)
				};
			},
			set json(_ref4) {
				var _ref4$body = _ref4.body,
				    body = _ref4$body === undefined ? '' : _ref4$body,
				    _ref4$ingredients = _ref4.ingredients,
				    ingredients = _ref4$ingredients === undefined ? [] : _ref4$ingredients;

				this.content = body;
				this.ingredients = ingredients.map(createObservableIngredient);
			},

			get contentTree() {
				return (0, _parser.parseInput)(this.content);
			},
			get activeScenario() {
				return this.scenarios[this.activeScenarioIndex];
			},
			get activeIngredients() {
				var activeScenario = this.activeScenario;
				return this.ingredients.reduce(function (object, _ref5) {
					var id = _ref5.id,
					    flattenedResult = _ref5.flattenedResult;

					object[id] = flattenedResult;
					return object;
				}, {});
			},
			activeVariationForIngredientAtIndex: function activeVariationForIngredientAtIndex(index) {
				var ingredient = this.ingredients[index];
				if (ingredient && ingredient.variations.length > 0) {
					var activeScenario = this.activeScenario;
					return ingredient.variations[_ramda2.default.propOr(0, ingredient.id, activeScenario)];
				}
			},

			addNewIngredient: _mobx.action.bound(function () {
				this.ingredients.push(createObservableIngredient({
					id: _ramda2.default.defaultTo('untitled', suggestReferenceFromTree(this.ingredients, this.contentTree)),
					type: 'text',
					variations: [{
						rawContent: ''
					}]
				}));
			}),
			onRemoveIngredientAtIndex: _mobx.action.bound(function (index) {
				this.ingredients.splice(index, 1);
			})
		});
	}

/***/ },
/* 106 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.parseInput = undefined;

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	var _parseInt = __webpack_require__(107);

	var _parseInt2 = _interopRequireDefault(_parseInt);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var _require = __webpack_require__(108),
	    parseElement = _require.parseElement;

	var rejectEmptyStrings = __webpack_require__(111);

	var addChildTo = _ramda2.default.curry(function (element, parent) {
		return _ramda2.default.mergeWith(_ramda2.default.concat, parent, {
			children: [element]
		});
	});

	var prefixAndBodyRegex = /^([0-9]?[-0-9.]*[-.])?\s*(.*)$/;
	var orderedPrefixRegex = /^[0-9]/;

	var parseInput = exports.parseInput = _ramda2.default.pipe(_ramda2.default.split('\n\n'), // sections
	_ramda2.default.map(_ramda2.default.pipe(_ramda2.default.split('\n'), // elements
	rejectEmptyStrings, // must have content
	_ramda2.default.reduce(function (items, itemInput) {
		var _R$tail = _ramda2.default.tail(_ramda2.default.match(prefixAndBodyRegex, itemInput)),
		    prefix = _R$tail[0],
		    body = _R$tail[1]; // just get captured


		if (body == null) {
			return items;
		}

		var element = parseElement(body);

		// Skip #research
		if (element.tags.research) {
			return items;
		}

		var isChild = prefix != null;
		if (isChild) {
			if (items.length === 0) {
				var ordered = _ramda2.default.test(orderedPrefixRegex, prefix);
				return [{
					text: null,
					tags: { list: true, ordered: ordered },
					references: [],
					children: [element]
				}];
			} else {
				return _ramda2.default.adjust(addChildTo(element), -1, items);
			}
		} else {
			return _ramda2.default.concat(items, element);
		}
	}, []))), _ramda2.default.reject(_ramda2.default.isEmpty));

/***/ },
/* 107 */
/***/ function(module, exports, __webpack_require__) {

	var root = __webpack_require__(57),
	    toString = __webpack_require__(69);

	/** Used to match leading and trailing whitespace. */
	var reTrimStart = /^\s+/;

	/* Built-in method references for those with the same name as other `lodash` methods. */
	var nativeParseInt = root.parseInt;

	/**
	 * Converts `string` to an integer of the specified radix. If `radix` is
	 * `undefined` or `0`, a `radix` of `10` is used unless `value` is a
	 * hexadecimal, in which case a `radix` of `16` is used.
	 *
	 * **Note:** This method aligns with the
	 * [ES5 implementation](https://es5.github.io/#x15.1.2.2) of `parseInt`.
	 *
	 * @static
	 * @memberOf _
	 * @since 1.1.0
	 * @category String
	 * @param {string} string The string to convert.
	 * @param {number} [radix=10] The radix to interpret `value` by.
	 * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
	 * @returns {number} Returns the converted integer.
	 * @example
	 *
	 * _.parseInt('08');
	 * // => 8
	 *
	 * _.map(['6', '08', '10'], _.parseInt);
	 * // => [6, 8, 10]
	 */
	function parseInt(string, radix, guard) {
	  if (guard || radix == null) {
	    radix = 0;
	  } else if (radix) {
	    radix = +radix;
	  }
	  return nativeParseInt(toString(string).replace(reTrimStart, ''), radix || 0);
	}

	module.exports = parseInt;


/***/ },
/* 108 */
/***/ function(module, exports, __webpack_require__) {

	const parseElement = __webpack_require__(109)

	module.exports = {
	    parseElement: parseElement
	}


/***/ },
/* 109 */
/***/ function(module, exports, __webpack_require__) {

	const R = __webpack_require__(6)

	const rejectEmptyStrings = __webpack_require__(110)

	const tagsRegex = /\B#\w+(:\s*[^#]*)?/g
	const mentionsRegex = /\B@([a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]+)*)/g

	const reduceMultipleSpaces = R.replace(/\s+/g, ' ')

	const convertToKeyPath = R.pipe(
		R.trim,
		R.split('.'),
		rejectEmptyStrings,
		R.map(R.when(
			R.test(/^\d/), // Starts with a digit
			(input) => parseInt(input, 10) // Convert to number
		))
	)

	const reduceTextAndMentionSeries = R.reduce((result, [text, mention]) => {
		if (text !== '' || mention != null) {
			result.texts.push(reduceMultipleSpaces(text))
			result.mentions.push(mention == null ? null : convertToKeyPath(mention))
		}
		return result
	})

	const parseTextAndMentions = R.pipe(
		R.split(mentionsRegex), // split at mentions
		R.splitEvery(2),
		(list) => reduceTextAndMentionSeries({ texts: [], mentions: [] }, list)
	)

	const parseTags = R.pipe(
		R.match(tagsRegex), // match tags,
		R.map(R.pipe(
			R.match(/\B#([a-zA-Z0-9-_]+)(:\s*([^#]*))?/), // capture tag elements,
			R.props([1, 3]),
			R.adjust(
				R.pipe(
					R.when(
						R.is(String),
						parseTextAndMentions
					),
					R.defaultTo(true)
				),
				1
			)
		)),
		R.fromPairs
	)

	const parseElement = R.converge(
		({ texts, mentions }, tags) => ({ texts, mentions, tags, children: [] }),
		[
			R.pipe(
				R.replace(tagsRegex, ''),
				R.trim(),
				parseTextAndMentions
			),
			parseTags
		]
	)

	module.exports = parseElement


/***/ },
/* 110 */
/***/ function(module, exports, __webpack_require__) {

	const R = __webpack_require__(6)

	const rejectEmptyStrings = R.filter(R.test(/\S/))

	module.exports = rejectEmptyStrings


/***/ },
/* 111 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var rejectEmptyStrings = _ramda2.default.filter(_ramda2.default.test(/\S/));

	module.exports = rejectEmptyStrings;

/***/ },
/* 112 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.stringRepresenterForType = exports.transformerForType = undefined;

	var _ramda = __webpack_require__(6);

	var _ramda2 = _interopRequireDefault(_ramda);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var transformRawContentCatching = function transformRawContentCatching(transform) {
		return _ramda2.default.converge(_ramda2.default.merge, [_ramda2.default.identity, _ramda2.default.tryCatch(_ramda2.default.pipe(_ramda2.default.prop('rawContent'), transform, _ramda2.default.merge({ error: null })), _ramda2.default.objOf('error'))]);
	};

	var transformerForType = exports.transformerForType = _ramda2.default.curry(function transformerForType(type, content) {
		if (type == 'json') {
			return {
				content: JSON.parse(content)
			};
		} else {
			return { content: content };
		}
	});

	var stringRepresenterForType = exports.stringRepresenterForType = _ramda2.default.curry(function stringRepresenterForType(type, content) {
		if (type == 'json') {
			return JSON.stringify(content, null, 2);
		} else {
			return content;
		}
	});

	exports.default = _ramda2.default.converge(_ramda2.default.call, [_ramda2.default.unary(_ramda2.default.merge), _ramda2.default.cond([[_ramda2.default.propEq('type', 'json'), _ramda2.default.evolve({
		variations: _ramda2.default.map(transformRawContentCatching(_ramda2.default.pipe(JSON.parse, _ramda2.default.objOf('content')
		/*R.converge(R.merge, [
	 	R.objOf('content'),
	 	R.pipe(
	 		R.curry(JSON.stringify)(R.__, null, 2),
	 		R.objOf('rawContent'),
	 	)
	 ])*/
		)))
	})], [_ramda2.default.T, _ramda2.default.evolve({
		variations: _ramda2.default.map(transformRawContentCatching(_ramda2.default.pipe(_ramda2.default.identity, _ramda2.default.objOf('content'))))
	})]])]);

/***/ },
/* 113 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _state = __webpack_require__(105);

	Object.defineProperty(exports, 'default', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_state).default;
	  }
	});

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/***/ }
/******/ ])
});
;